<?php
 class ContactController extends Controller{
 	
	 	function __construct($name){
			parent::__construct($name);
		}
		
		public function index(){
			
			$language = loadLanguage("contact");

			if($_SERVER['REQUEST_METHOD'] == "POST"){
				
				$data = $_POST['data'];
								
				$errors = $this->validate($data);
								
				if(count($errors) == 0){
					$this->sendEmail($data);
					$_SESSION['success'] = $language['success'];
					header('location: ./index.php?r=contact');
					exit();
				}
				
			}else{
				
				$errors = array();
				$data = array();
				
			}
			
			if(isset($_SESSION['success'])){
				$success = $_SESSION['success'];
				unset($_SESSION['success']);
			}else{
				$success = "";
			}
			
			$conexionContacto = loadModel('contacto');
			$contact = $conexionContacto->getContact();

			$this->viewDatas['success']  = $success;
			$this->viewDatas['errors'] 	 = $errors;
			$this->viewDatas['data']	 = $data;
			$this->viewDatas['contacto'] = $contact;
			$this->viewDatas['language'] = $language;

			return $this->render('contact', APP_NAME." - Contacto","leasing","leasing");
			
		}
		
		private function sendEmail($data){
			$contactModel 	= loadModel('contacto');
			$tmp 		  	= $contactModel->getEmails();
			$emailsList   	= explode("-", $tmp['emails']);
			$language       = loadLanguage('contact');
			$data['origin'] = 'http://' . $_SERVER["SERVER_NAME"] . $_SERVER["REQUEST_URI"];

			$emails = array();

			//Email para el administrador
			foreach ($emailsList as $emailTo) {
				$emails[] = array(
  								'email_from' => $data['email'],
  								'name_from'  => $data['name'],
  								'email_to'   => $emailTo,
  								'name_to'	 => $emailTo,
  								'subject'    => 'Email enviado desde contacto',
  								'message'	 => loadView('mails/contact_admin', array('data' => $data))
					        );
			}

			//Email para el cliente
			$emails[] = array(
							'email_from' => 'contacto@kupla.com.mx',
							'name_from'	 => 'Kupla',
							'email_to'	 => $data['email'],
							'name_to'    => $data['name'],
							'subject'    => $language['email_subject'],
							'message'	 => loadView('mails/contact_customer', array('message' => $language['email_text']))
				 	  	);

			sendEmail($emails);
		}
		
		private function validate($data){
			
			$errors   = array();
			$language = loadLanguage("contact");

			if($data['name'] == ""){
				
				$errors[] = $language['name_error'];
				
			}
			
			if($data['email'] == ""){
				
				$errors[] = $language['email_error'];
				
			}else{
				
				if(!preg_match(EXPREG_EMAIL, $data['email'])){
					
					$errors[] = $language['email_invalid'];	
					
				}
				
			}

			if($data['city'] == ""){
				
				$errors[] = "Ingrese su ciudad";
				
			}
			

			if($data['telephone'] == ""){
				
				$errors[] = "Ingese un n&uacute;mero telefonico";
				
			}
			
			if($data['comments'] == ""){
				
				$errors[] = $language['comments_error'];
				
			}
			
						
			return $errors;
			
		}
 	
 }
 ?>
