<?php
class InformationController extends Controller{
	
	function __construct($name){
		parent::__construct($name);
	}
		
	public function index(){
		//Obtenemos el id de la categoria padre
		if(isset($_GET['root'])){
			$root = $_GET['root'];
		}else{
			header("location:./index.php");
		}

		$this->viewDatas['root_info'] = $root;

		if($root == 1){
			$this->viewDatas['unidades_slider'] = loadView('unidades_slider');
		}
		
		//Cargamos el respectivo modelo
		$informationModel = loadModel("information");
		
		//Si selecciona una subcategoria
		if(isset($_GET['subcat'])){
			$subcat = $_GET['subcat'];
		}else{
			$subcat = "";
		}

		//Si se selecciona un articulo especifico
		if(isset($_GET['id'])){
			$id = $_GET['id'];
		}else{
			$id = "";			
		}

		if($subcat == "" && $id == ""){
			$tmp     = $informationModel->getCategoryById($root);
			$article = array(
						'title' => $tmp['name'],
						'content' => $tmp['description'],
						'seo_titulo' => $tmp['seo_titulo'],
						'meta_description' => $tmp['meta_description'],
						'meta_keywords' => $tmp['meta_keywords'],
			);
		}else if ($subcat != "" && $id == "") {
			$tmp 	 = $informationModel->getArticlesByCat($subcat);
			$id  	 = $tmp[0]['id'];
			$article = $informationModel->getArticleById($id);
		}else if ($id != "") {
			$article = $informationModel->getArticleById($id);
		}



		$this->viewDatas['left_menu'] = $this->makeMenu($root, $subcat, $id);

		$this->viewDatas['article']	  = $article;
		
		return $this->render('information',$article['seo_titulo'],$article['meta_description'],$article['meta_keywords']);
		
	}
		
	private function makeMenu($root_id, $subcat_id, $article_id){
					
		$informationModel = loadModel("information");
																			
		$menu = "";
		
		$menu .= "<ul>";

			if($article_id == '1' || $article_id == '2' ){
				if($article_id == '1'){
					$menu .= "<li><a class='active' href='".encode_seo("./index.php?r=information&root=1&id=1")."'>ARRENDAMIENTO<br><label>PURO</label></a></li>";
				}else{
					$menu .= "<li><a href='".encode_seo("./index.php?r=information&root=1&id=1")."'>ARRENDAMIENTO<br><label>PURO</label></a></li>";
				}
				if($article_id == '2'){
					$menu .= "<li><a class='active' href='".encode_seo("./index.php?r=information&root=1&id=2")."'>ARRENDAMIENTO<br><label>FINANCIERO</label></a></li>";
				}else{
					$menu .= "<li><a href='".encode_seo("./index.php?r=information&root=1&id=2")."'>ARRENDAMIENTO<br><label>FINANCIERO</label></a></li>";
				}
			}
			
			if($article_id == '4' || $article_id == '5' ){
				if($article_id == '5'){
					$menu .= "<li><a class='active' href='".encode_seo("./index.php?r=information&root=2&id=5")."'>CR&Eacute;DITO <br><label style='color:#fff;font-size:12px'>CON GARANT&Iacute;A HIPOTECARIA</label><br><label>DE CORTO PLAZO</label></a></li>";
				}else{
					$menu .= "<li><a href='".encode_seo("./index.php?r=information&root=2&id=5")."'>CR&Eacute;DITO<br><label style='color:#fff;font-size:12px'>CON GARANT&Iacute;A HIPOTECARIA</label><br><label>DE CORTO PLAZO</label></a></li>";
				}
				if($article_id == '4'){
					$menu .= "<li><a class='active' href='".encode_seo("./index.php?r=information&root=2&id=4")."'>CR&Eacute;DITO<br><label style='color:#fff;font-size:12px'>CON GARANT&Iacute;A HIPOTECARIA</label><br><label>DE LARGO PLAZO</label></a></li>";
				}else{
					$menu .= "<li><a href='".encode_seo("./index.php?r=information&root=2&id=4")."'>CR&Eacute;DITO <br><label style='color:#fff;font-size:12px'>CON GARANT&Iacute;A HIPOTECARIA</label><br><label>DE LARGO PLAZO</label></a></li>";
				}
			}

		$menu .= "</ul>";
				
		return $menu;
		
	}
	
}
?>