<?php
/**
* 
*/
class ProductController extends Controller
{
	
	function __construct($name)
	{
		parent::__construct($name);
	}

	public function index(){

		$productModel = loadModel('product');

		//Obtener la categoría del producto
		if(isset($_GET['category'])){
			$category_id = $_GET['category'];
		}else{
			$category_id = "";
		}

		//Obtener el listado de productos por categoría
		if($category_id != ""){
			$products = $productModel->getProductsByCategory($category_id);
		}else{
			$products = array();
		}

		/*Paginación*/
		if(isset($_GET['page'])){
			$page = $_GET['page'];
		}else{
			$page = 1;
		}

		$quantity = 6;
		$url	  = "./index.php?r=product&category=".$category_id;

		$pagination = new paginator(count($products), $page, $quantity);
		$products   = array_slice($products, $pagination->getStart(), $quantity);

		//Obtener listado de categorías de productos
		$categories = $productModel->getProductCategories();

		$this->viewDatas['products']    = $products;
		$this->viewDatas['categories']  = $categories;
		$this->viewDatas['pagination']  = $pagination->getView($url);
		$this->viewDatas['category_id'] = $category_id;
		$this->viewDatas['language']	= loadLanguage('product');

		return $this->render('product_list');

	}

	public function detail(){
		if(isset($_GET['id'])){
			$id = $_GET['id'];
		}else{
			header("location: ./index.php?r=product");
			exit();
		}

		$productModel = loadModel('product');

		//Obtener la información del producto
		$product = $productModel->getProductById($id);

		//Obtener listado de categorías de productos
		$categories = $productModel->getProductCategories();

		//Pasar los datos a la vista
		$this->viewDatas['product']    = $product;
		$this->viewDatas['categories'] = $categories;
		$this->viewDatas['language']   = loadLanguage('product');

		return $this->render('product_detail');
	}

	public function sendToFriend(){
		$datas 				   = array();
		$language 			   = loadLanguage("product");
		$datas['name'] 		   = $_POST['name'];
		$datas['email'] 	   = $_POST['email'];
		$datas['friend_name']  = $_POST['friend_name'];
		$datas['friend_email'] = $_POST['friend_email'];
		$datas['comments'] 	   = $_POST['comments'];
		$datas['image']        = $_POST['image'];
		$datas['product_url']  = $_POST['product_url'];
		$datas['product_name'] = $_POST['product_name'];

		$message			   = sprintf($language['email_text'], 
										 	$datas['friend_name'], 
										 	$datas['name'], 
										 	APP_NAME,
										 	$datas['product_url'],
										 	$datas['product_name'],
										 	$datas['name'],
										 	$datas['comments']);

		$erros = $this->validateForm($datas);
		if(count($erros) == 0){
			$emails = array();

			$emails[] = array(
							'name_from' => $datas['name'],
							'email_from' => $datas['email'],
							'name_to'    => $datas['friend_name'],
							'email_to'   => $datas['friend_email'],
							'subject'    => sprintf($language['email_subject'], $datas['name']),
							'message'    => loadView('mails/send_friend', array('message' => $message, 'image' => $datas['image']))
 						);

			sendEmail($emails);
		}

		return json_encode($erros);
	}

	private function validateForm($datas){
		$erros    = array();
		$language = loadLanguage("product");

		if($datas['name'] == ""){
			$erros[] = $language['name_error'];
		}

		if($datas['email'] == ""){
			$erros[] = $language['email_error'];
		}else if (!preg_match(EXPREG_EMAIL, $datas['email'])) {
			$erros[] = $language['email_invalid'];
		}

		if($datas['friend_name'] == ""){
			$erros[] = $language['friend_name_error'];
		}

		if($datas['friend_email'] == ""){
			$erros[] = $language['friend_email_error'];
		}elseif (!preg_match(EXPREG_EMAIL, $datas['friend_email'])) {
			$erros[] = $language['friend_email_invalid'];
		}

		return $erros;
	}
}
?>