<?php
abstract class Controller{
	
	private		$name;
	private		$code;
	protected	$viewDatas = array();
	
	public function __construct($name){
		$this->name = $name;
		$this->code = strtolower(str_replace("Controller", "", $name));
	}
	
	abstract public function index();
	
	public function getName(){
		return $this->name;
	}
	
	public function getCode(){
		return $this->code;
	}
	
	public function render($view, $title = "", $meta_description = "",$meta_keywords=""){
		
		$headerController = loadController("header");
		$footerController = loadController("footer");
		
		$layoutDatas = array();
		$layoutDatas['header']  		 = $headerController->index();
		$layoutDatas['view']  			 = $view;
		$layoutDatas['title']  			 = $title;
		$layoutDatas['meta_description'] = $meta_description;
		$layoutDatas['meta_keywords']	 = $meta_keywords;
		$layoutDatas['content'] 		 = loadView($view, $this->viewDatas);
		$layoutDatas['footer']  		 = $footerController->index();
		
		return loadView("layout", $layoutDatas);
		
	}
	
}//class
?>