<?php
error_reporting(0);
/*
 * Las sessiones que tienen guiones bajos en sus nombres
 * es porque sus valores no deben de ser tomados de manera
 * directa.
 */

session_start();

// -------------------------------------------------------------------------
define("VERSION",           		"2.0");

//PATHS
define("PATH_LIBRARY",          	"./front/library");
define("PATH_FILES",          		"./files/");
define("PATH_SLIDERS",          	"./files/slider/");
define("PATH_HOUSES",               "./files/casas/");

define("PATH_CONTROLLERS",      	"./front/controllers");
define("PATH_VIEWS",            	"./front/views");
define("PATH_IMG",            		PATH_VIEWS."/".TEMPLATE."/img/");
define("PATH_MODELS",           	"./front/models");
define("PATH_LANGUAGES",        	"./front/languages");

define("NO_IMAGE",					"empty.png");

//ACTIONS
define("DEFAULT_ACTION",    		"home-index");

define("MODE_SEO", 0);

if(isset($_GET['_r_'])){
	if(function_exists('decode_seo') && function_exists('encode_seo')){
		decode_seo();
	}else{
		echo "Defina las funciones decode_seo y encode_seo en el config.php";
	}
}

//ROUTE
if(isset($_GET['r']) && $_GET['r'] != ""){
    define("ROUTE", $_GET['r']);
}else{
    define("ROUTE", DEFAULT_ACTION);
}

//LANGUAGE
if(isset($_GET['l']) && $_GET['l'] != ""){
    define("LANGUAGE", $_GET['l']);
    $_SESSION['_LANGUAGE_'] = LANGUAGE;
}else if(isset($_SESSION['_LANGUAGE_']) && $_SESSION['_LANGUAGE_'] != "" ){
    define("LANGUAGE", $_SESSION['_LANGUAGE_']);
}else{
    define("LANGUAGE", DEFAULT_LANGUAGE);
    $_SESSION['_LANGUAGE_'] = LANGUAGE;
}

//TOOLS
define("CHARSET",               "utf-8");
define("EXPREG_TELEPHONE",     "/^(\(?[0-9]{3,3}\)?|[0-9]{3,3}[-. ]?)[ ][0-9]{3,3}[-. ]?[0-9]{4,4}$/");
define("EXPREG_EMAIL",         "/^[^0-9][a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)*[@][a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)*[.][a-zA-Z]{2,4}$/");

//LOAD CLASSES
require_once dirname(__FILE__).'/MySQL.class.php';
require_once dirname(__FILE__).'/Controller.class.php';
require_once dirname(__FILE__).'/Model.class.php';
require_once dirname(__FILE__).'/Paginator.class.php';
require_once dirname(__FILE__).'/Thumbnail.class.php';
require_once dirname(__FILE__).'/InputTypeSelect.class.php';

//FUNCTIONS ----------------------------------------------------------------
function ejecute(){
	$parts = explode("-", ROUTE);
	$controller = loadController($parts[0]);
	
	if($parts[1] == ""){
		$metodo = "index";
	}else{
		$metodo = $parts[1];
	}	
	$reflexion = new ReflectionClass($controller->getName());
	if($reflexion->hasMethod($metodo)){
		echo $controller->$metodo();
	}else{
		exit("El controlador <b>".$controller->getName()."</b> no tiene definido el metodo <b>{$metodo}</b>");
	}
}

function loadController($controller){
	$nameController = ucfirst($controller)."Controller";
    $path = PATH_CONTROLLERS."/$nameController.class.php";
    if (is_file($path)){
        require_once ($path);
        return new $nameController($nameController);
    }else{
    	exit("El controlador <b>$nameController</b> no existe en <b>$path</b>");
    }
}

function loadView($view, $datas = array()){
    $path = PATH_VIEWS."/".TEMPLATE."/$view.php";
    extract($datas);
    if (is_file($path)){
        ob_start();
        require ($path);
        $content = ob_get_contents();
        ob_end_clean();
        return $content;
    }else{
        exit("La vista <b>$view</b> no existe en <b>$path</b>");
    }
}

function loadModel($model){
	$nameModel = ucfirst($model)."Model";
    $path = PATH_MODELS."/$nameModel.class.php";
    if (is_file($path)){
        require_once($path);
        return new $nameModel();
    }else{
    	exit("El Modelo <b>$nameModel</b> no existe en <b>$path</b>");
    }
}

function loadLanguage($language){
    $path = PATH_LANGUAGES.'/'.LANGUAGE."/$language.php";
    
    if (is_file($path)){
        require $path;
        return $i18n;
    } else {        
    	exit("El languaje <b>$language</b> no existe en <b>$path</b>");
    }
        
}


function formatName($string, $limit=30){
    if(strlen($string) > $limit){
        return $string;
    }else{
        return $string;
    }
}

function formatPrice($price){
    return "$ ".number_format($price, 2, '.', ',')." MXN";
}

function formatImage($path, $image, $size){
	
	$parts = explode("x", $size);

	if($image == ""){
		$image = NO_IMAGE;
		$pathImage = PATH_VIEWS."/".TEMPLATE."/img/".$image;
    }else{
    	if(is_file($path."/".$image)){
			$pathImage = $path."/".$image;
    	}else{
			$image = NO_IMAGE;
			$pathImage = PATH_VIEWS."/".TEMPLATE."/img/".$image;
		}
    }

	$pathThumbnail = $path."/".$size."_".$image;
	
	if(!is_file($pathThumbnail)){
		$thumbnail = new Thumbnail($pathImage, $pathThumbnail);
    	$thumbnail->create($parts[0], $parts[1]);
	}
    
    return $pathThumbnail;
}

function scaleFromHeight($path, $image, $size){
	
	$parts = explode("x", $size);

	if($image == ""){
		$image = NO_IMAGE;
		$pathImage = PATH_VIEWS."/".TEMPLATE."/img/".$image;
    }else{
    	if(is_file($path."/".$image)){
			$pathImage = $path."/".$image;
    	}else{
			$image = NO_IMAGE;
			$pathImage = PATH_VIEWS."/".TEMPLATE."/img/".$image;
		}
    }

	$pathThumbnail = $path."/".$size."_".$image;
	
	if(!is_file($pathThumbnail)){
		$thumbnail = new Thumbnail($pathImage, $pathThumbnail);
    	$thumbnail->scaleFromHeight($parts[1], true);
	}
    
    return $pathThumbnail;
}

function isTypeImage($type){
	$types = array("image/gif", "image/jpeg", "image/png", "image/pjpeg");
	return in_array($type, $types);
}

function sendEmail($emails){
	require_once PATH_LIBRARY.'/phpMailer/class.phpmailer.php';
	require_once PATH_LIBRARY.'/phpMailer/class.smtp.php';
	
	
	$mail 					= new PHPMailer();
	$mail->IsSMTP();
	$mail->SMTPDebug  		= 0;
	$mail->Host  			= "mail.kupla.com.mx";
	$mail->SMTPAuth 		= true;
	$mail->SMTPKeepAlive	= true;                  // SMTP connection will not close
	$mail->Port 			= 26;
	$mail->Username 		= "no-reply@kupla.com.mx";
	$mail->Password 		= "qwerty123*";
	$mail->IsHTML(true);
	
	foreach ($emails as $email){
		
		$mail->From       = $email['email_from'];
		$mail->FromName   = $email['name_from'];
			
		$mail->Subject    = $email['subject'];
			
		$mail->AltBody    = "Tu webmail no soporta html";
		$mail->MsgHTML($email['message']);
		$mail->AddAddress($email['email_to'], $email['name_to']);
		if(!$mail->Send()){
			echo "Mailer Error: " . $mail->ErrorInfo;
			//return false;
		}else{
				//return true;
		}
		
		$mail->ClearAddresses();
	}
	
}

function getSettings($type, $key){
	$settingsModel = loadModel("settings");
	$value = $settingsModel->getValue($type, $key);
	return $value;
}

function redirect($url){
	header("location: ".$url);
	exit();
}


function log_wl($sql = ""){
	$day   = date('d');
	$month = date('m');
	$year  = date('Y');
	$date = $day."_".$month."_".$year;
	$text  = date('Y-m-d G:i:s').", ";
	$text .= $_SERVER['REMOTE_ADDR'].", ";
	$text .= (isset($_SESSION['user_id']))? $_SESSION['user_id'].", " : "N/A, ";
	//$text .= $_SESSION['HTTP_USER_AGENT'].", ";
	$text .= $_SERVER['REQUEST_METHOD'].", ";
	$text .= $_SERVER['SERVER_PROTOCOL'].", ";
	$text .= $_SERVER['SERVER_NAME'].", ";
	$text .= $_SERVER['SERVER_PORT'].", ";
	$text .= $_SERVER['QUERY_STRING'].", ";
	$text .= $sql."\n";

	$ruta_log = "./logs/".$date.".txt";

	$handle = fopen($ruta_log, 'a+');
	fwrite($handle, $text);
	fclose($handle);
}

?>