<?php
	//security
	if(!defined('IS_INDEX') || IS_INDEX != true){
		exit();
	}
?>

<div id="house_content">
	<div id='left_menu' class="menu_responsivo">
		<?= $left_menu ?>
	</div>
	
	<div id="house">
		<h3><?= $house['name'] ?></h3>
		<?php if(count($house['images']) > 0){ ?>
			<div style='clear:both;'></div>
			<!-- La imagene en tamaño normal -->
			<div id='normal_img'>
				<a id='btn-show-modal' href='#' data-num-img=''><img src="" style="width:100%;"></a>
			</div>
			<div style='clear:both;'></div>
			<!-- Contador del numero de imagenes -->
			<div id="bx-num_img">
				<img src="<?= PATH_VIEWS ?>/default/img/ico_camara.png" style="vertical-align: middle;">&nbsp;<span id='current'>1</span> / <span id='total'><?= count($house['images']) ?></span>
			</div>
			<div style='clear:both;'></div>
			<!-- Carousel de miniaturas -->
			<div id='thumbs'>
				<ul class='bxslider'>
					<?php
						$i = 1;
						foreach ($house['images'] as $value) {
							$img    = $value['id']."-".$value['name'];
							$size   = "80x80";
							$size2  = "700x500";
							$path   = PATH_HOUSES;
							$thumb  = formatImage($path, $img, $size);
							$normal = formatImage($path, $img, $size2);
							echo "<li><a data-normal-img='".$normal."' href='#' class='thumb' data-num-img='".$i."'><img src='".$thumb."' /></a></li>";
							$i++;
						}
					?>
				</ul>
			</div>
		<?php } ?>
		<div style='clear:both; margin-bottom:20px;'></div>
		<?= $house['content'] ?>
	</div>

	<!-- Versión movil de las imagenes de las casas -->
	<div id="house_movil">
		<h3><?= $house['name'] ?></h3>
		<div style='clear:both;'></div>
		<ul class='bxslider_movil'>
			<?php 
				foreach ($house['images'] as $value) {
					echo "<li><a href='#'><img src='".PATH_HOUSES."/".$value['id']."-".$value['name']."' /></a></li>";
				}
			?>
		</ul>
		<div style='clear:both;'></div>
		<div id="bx-num_img">
			<a id="prev-btn"></a>
			<img src="<?= PATH_VIEWS ?>/default/img/ico_camara.png" style="vertical-align: middle;">
			&nbsp;<span id='current_movil'>1</span> / <span id='total'><?= count($house['images']) ?></span>
			<a id="next-btn"></a>
		</div>
		<div style="clear:both; margin-bottom:20px;"></div>
		<?= $house['content'] ?>
	</div>

	<div id="down_menu" class="menu_responsivo">
		<?= $left_menu ?>
	</div>

	<!-- Ventana Modal -->
	<div id="housesModal" class="reveal-modal">
		<div id="modal-big-image">
			<img src="">
		</div>
		<div style='clear:both;'></div>
		<div id="num_img-modal">
			<img src="<?= PATH_VIEWS ?>/default/img/ico_camara.png" style="vertical-align: middle;">&nbsp;<span id='current-modal'>1</span> / <span id='total'><?= count($house['images']) ?></span>
		</div>
		<div style='clear:both;'></div>
		<div id='thumbs-modal'>
			<ul class='bxslider-modal'>
				<?php
					$i = 1;
					foreach ($house['images'] as $value) {
						$img    = $value['id']."-".$value['name'];
						$size   = "80x80";
						$size2  = "700x500";
						$path   = PATH_HOUSES;
						$thumb  = formatImage($path, $img, $size);
						$normal = formatImage($path, $img, $size2);
						echo "<li><a data-normal-img='".$normal."' href='#' class='thumb-modal' data-num-img='".$i."'><img src='".$thumb."' /></a></li>";
						$i++;
					}
				?>
			</ul>
		</div>
		<a id="close_modal_btn" class="close-reveal-modal">&#215;</a>
	</div>

</div>

<script type="text/javascript">
	var slider_modal = "";

	$(document).ready(function(){
		
		$('#thumbs img').first().addClass('active');

		var firstImage = $('#thumbs a').first().attr('data-normal-img');
		
		$('#normal_img img').attr('src', firstImage);
		
		//Carousel en versión de escritorio
  		$('.bxslider').bxSlider({
  			infiniteLoop: false,
			maxSlides: 3,
			slideWidth: 82,
			moveSlides: 1,
			slideMargin: 5,
  			pager: false
  		});

  		//Carousel en la ventana modal
  		slider_modal = $('.bxslider-modal').bxSlider({
					  		infiniteLoop: false,
					  		maxSlides: 3,
							slideWidth: 82,
							moveSlides: 1,
							slideMargin: 5,
					  		pager: false
  						});

  		//Slider en la version movil
  		$('.bxslider_movil').bxSlider({
  			pager: false,
  			prevSelector: $('#prev-btn'),
  			nextSelector: $('#next-btn'),
  			infiniteLoop: false,
  			onSlideAfter: function($slideElement, oldIndex, newIndex){
  				$('#current_movil').text(newIndex+1);
  			}
  		});

	});

	//Funciones al hacer click sobre una miniatura del carousel
	$('.thumb').click(function(e){
		//Remover la clase active de las demas imagenes
		$( "#thumbs img" ).each( function( index, element ){
    		$( this ).removeClass('active');
		});
		
		//Agregar la clase active a la imagen que seleccionamos
		$(this).find('img').addClass('active');

		/*
		Obtener la ruta de la imagen en tamaño normal
		Cambiar la imagen a mostrar en tamaño normal
		*/
		var new_img = $(this).attr('data-normal-img');
		$('#normal_img img').attr('src', new_img);

		/*
		Obtener el numero de la imagen que seleccionamos
		Cambiar la posicion en la que nos encontramos
		*/
		var num_img = $(this).attr('data-num-img');
		$('#normal_img a').attr('data-num-img', num_img);
		$('#current').text(num_img);

		e.preventDefault();
	});

	//Funciones al hacer click sobre una miniatura del carousel en la ventana modal
	$('.thumb-modal').click(function(e){
		//Remover la clase active de las demas imagenes
		$( "#thumbs-modal img" ).each( function( index, element ){
    		$( this ).removeClass('active');
		});
		
		//Agregar la clase active a la imagen que seleccionamos
		$(this).find('img').addClass('active');

		/*
		Obtener la ruta de la imagen en tamaño normal
		Cambiar la imagen a mostrar en tamaño normal
		*/
		var new_img = $(this).attr('data-normal-img');
		$('#modal-big-image img').attr('src', new_img);

		/*
		Obtener el numero de la imagen que seleccionamos
		Cambiar la posicion en la que nos encontramos
		*/
		var num_img = $(this).attr('data-num-img');
		$('#current-modal').text(num_img);

		e.preventDefault();
	});

	/****Abrir la ventana modal****/
	$('#btn-show-modal').click(function(e){
		//Obtener la ruta de la imagen de tamaño normal que se selecciono
		var img     = $(this).find('img').attr('src');

		//Obtener el numero de imagen que se selecciono
		var num_img = $(this).attr('data-num-img');
		var active	= num_img - 1;


		if(num_img > 3 && num_img % 3 != 0){
			num_img = num_img - 3;
		}else{
			num_img = num_img - 1;
		}
		
		//Movemos el slider a la posicion de la imagen seleccionada
		slider_modal.goToSlide(num_img);

		//Quitar a todas las miniaturas la clase active
		$( "#thumbs-modal img" ).each( function( index, element ){
    		$( this ).removeClass('active');
		});

		//Obtener el array con toda las miniaturas
		var thumbs_modal = $('#thumbs-modal img');

		//Agregar la clase active a la imagen que se selecciono
		thumbs_modal.eq(active).addClass('active');

		//Poner la ruta en la imagen en tamaño normal que se selecciono
		$('#modal-big-image').find('img').attr('src', img);

		$('#current-modal').text($(this).attr('data-num-img'));

		$('#thumbs-modal').css('display', 'block');

		//Abrir ventana modal
		$('#housesModal').reveal({
			closeonbackgroundclick: false
		});

		e.preventDefault();
	});

	//Cerrar la ventana modal
	$('#close_modal_btn').click(function(e){
		$('#thumbs-modal').css('display', 'none');
	});

</script>