<?php

class ImagenMiniatura {

    protected $dirImg;
    protected $dirMini;

    protected $img;
    protected $ancho;
    protected $alto;
    protected $mime;
    protected $bits;//profundidad de bits (no disponible para todos los tipos de imagenes)

    public function __construct($dirImg,$dirMini=".") {
        
        if(is_file($dirImg)){
            $this->dirMini=$dirMini;
            $this->dirImg=$dirImg;

            $info = getimagesize($this->dirImg);
            $this->ancho = $info[0];
            $this->alto = $info[1];
            $this->mime = $info['mime'];
            $this->bits = $info['bits'];

            //print_r($info);
            if ($this->mime == 'image/gif') {
                $this->img = imagecreatefromgif($this->dirImg);
            } else if ($this->mime == 'image/png') {
                $this->img = imagecreatefrompng($this->dirImg);
            } else if ($this->mime == 'image/jpeg'){
                $this->img = imagecreatefromjpeg($this->dirImg);
            }
        }
    }

    public function crear($anchoMini=75,$altoMini=75){

        if(!is_file($this->dirImg)){
            return;
        }
        
        //imagen original
        //$ancho=$this->ancho;
        //$alto=$this->alto;
        
        //imagen miniatura
        //$anchoMini=$anchoMini;
        //$altoMini=$altoMini;

        //nuevo tamaño de la imagen original reducida dentro de la miniatura
        $ancho_tmp;
        $alto_tmp;

        
        if($this->alto <= $altoMini){                           //si el alto esta bien?
            $alto_tmp=$this->alto;                              //es el alto bueno

            if($this->ancho <= $anchoMini){                     //si el ancho esta bien?
                $ancho_tmp=$this->ancho;                        //es el ancho bueno
            }else{
                $rel=$anchoMini/$this->ancho;                   //calculo la relacion de anchos
                $ancho_tmp=$this->ancho*$rel;                   //reduzco el ancho (afecta al alto)
                $alto_tmp=$alto_tmp*$rel;                       //escalo el alto
            }
        }else{
            $rel=$altoMini/$this->alto;                         //calculo la relacion de altos
            $alto_tmp=$this->alto*$rel;                         //reduzco el ancho (afecta al ancho)
            $ancho_tmp=$this->ancho*$rel;                       //escalo el alto

            if($ancho_tmp <= $anchoMini){                       //si el ancho esta bien?
                $ancho_tmp=$ancho_tmp;                          //es el ancho bueno (no cambia)
            }else{
                $rel=$anchoMini/$ancho_tmp;                     //calculo la relacion
                $ancho_tmp=$ancho_tmp*$rel;                     //reduzco el ancho (afecta al alto)
                $alto_tmp=$alto_tmp*$rel;                       //escalo el alto
            }
        }

        //centrar imagen en imagenMiniatura
        $x=floor(($anchoMini-$ancho_tmp)/2);
        $y=floor(($altoMini-$alto_tmp)/2);
        $tmp_img = imagecreatetruecolor( $anchoMini, $altoMini);

        //color de fondo de la miniatura
        $white = imagecolorallocate($tmp_img, 255, 255, 255);
        imagefilledrectangle ( $tmp_img, 0, 0, $anchoMini, $altoMini, $white );

        //imagefilter($this->img, IMG_FILTER_GAUSSIAN_BLUR, 10);
        //imagecopyresized( $tmp_img, $this->img, $x, $y, 0, 0, $ancho_tmp, $alto_tmp, $this->ancho, $this->alto);
        imagecopyresampled ( $tmp_img, $this->img, $x, $y, 0, 0, $ancho_tmp, $alto_tmp, $this->ancho, $this->alto);
        //guardar la imagen con la maxima calidad
        if ($this->mime == 'image/gif') {
            imagegif($tmp_img, $this->dirMini);
        } else if ($this->mime == 'image/png') {
            imagepng($tmp_img, $this->dirMini, 9);
        } else if ($this->mime == 'image/jpeg'){
            imagejpeg($tmp_img, $this->dirMini,1000);
        }

        //liberar memoria
        imagedestroy($tmp_img);
        imagedestroy($this->img);
    }
}







/*
 * imagecreatefromgd2 -- Create a new image from GD2 file or URL
imagecreatefromgd2part -- Create a new image from a given part of GD2 file or URL
imagecreatefromgd -- Create a new image from GD file or URL
imagecreatefromgif -- Crear una nueva imagen a partir de un archivo o URL
imagecreatefromjpeg -- Crea una imagen nueva desde un archivo o URL
imagecreatefrompng -- Crea una imagen nueva desde un archivo o URL
imagecreatefromstring -- Create a new image from the image stream in the string
imagecreatefromwbmp -- Create a new image from file or URL
imagecreatefromxbm -- Create a new image from file or URL
imagecreatefromxpm -- Create a new image from file or URL
imagecreatetruecolor -- Crea una imagen nueva en color real (true color)
 */














    //public function reduccionProporcional($nuevoAncho, $anchoOriginal,$altoOriginal){
        //si el ancho nuevo tiene un 30% del ancho original entonces
        //el alto nuevo tendra tambien un 30% de su altura original,
        //puesto que estamos reduciendo proporcionalmente.
        //
        //si la anchura solicitada es 75px de una imagen de 300px entones
        //¿cuanto por ciento de la imagen original nos da 75px?;
        //(75 x 100% )/300 =25% (regla de 3)

        //si se solicita una imagen de 75px de ancho (el 25% de un ancho original de 300px) entoces
        //el alto sera 100px (25% de un alto de 400px);

      //  $porciento=($nuevoAncho *100)/$anchoOriginal;
      //  $nuevoAlto= ($porciento*$altoOriginal)/100;

        //redondear ya que no existen fracciones de pixeles

        //return floor($nuevoAlto);
    //}

?>
