<?php
class Paginacion{
	private $totalResultados;
	private $paginaActual;
	private $cantMostrar;								//cantidad de registros que se mostraran en la pagina, por default 25
	
	private $totalPaginas;								//cantidad de paginas que se necesitan para mostrar todos los resultados
	private $sigRegistro;								//primer resultado de la siguiente pagina	
	
	private $estiloPaginaActual;						//clase CSS que se usara para diferenciar la pagina actual
	private $estiloPaginas;								//clase CSS que se usara para las demas paginas
	
        private $cadFiltros = "";
        private $varPagina = "";
        private $url = "";
        
	function __construct($totalResultados,$paginaActual,$cantMostrar=25){
	 	
		if($paginaActual==""){
			$this->paginaActual=0;
		}else{
			$this->paginaActual=$paginaActual;
		}
		
		$this->totalResultados=$totalResultados;
		$this->cantMostrar=$cantMostrar;
		//calculos
		$this->totalPaginas=ceil($this->totalResultados/$this->cantMostrar);
		$this->sigRegistro=$this->paginaActual*$this->cantMostrar;
	}
	
	public function obtenerSiguienteRegistro(){
		return $this->sigRegistro;
	}
	public function obtenerCantMostrar(){
		return $this->cantMostrar;
	}
        
        //nuevo
	public function agregarFiltros($arrayFiltros){
            if(is_array($arrayFiltros)){
                foreach ($arrayFiltros as $key => $value){
                    $this->cadFiltros .= "&filtros[" . $key . "]=" . $value;
                }
            }
        }
        
        //nuevo
        public function establecerVariablePagina($nombreVar){
            $this->varPagina=$nombreVar;
        }
        
        //nuevo
        public function establecerUrl($url){
            $this->url= $url;
        }
        
        //refactorizado
        public function obtenerPaginacionHTML($classControl){
		/*"$nombreVar" es nombre de la variable que se usara para dar seguimiento
		a las paginas (es el mismo que se debe de recibir en el contructor)*/
		$paginacionHTML.="<div id='$classControl'>";
		for($i=0;$i<$this->totalPaginas;$i++){
			if($i==$this->paginaActual){
                            $paginacionHTML.="<a href='{$this->url}{$this->cadFiltros}&{$this->varPagina}=$i'><b>".($i+1)."</b></a>";
				//$paginacionHTML.="<input type='submit' name='$nombreVar' value='".($i+1)."' class='$estiloPaginaActual' />";
			}else{
                            $paginacionHTML.="<a href='{$this->url}{$this->cadFiltros}&{$this->varPagina}=$i'>".($i+1)."</a>";
				//$paginacionHTML.="<input type='submit' name='$nombreVar' value='".($i+1)."' class='$estiloPaginas' />";
			}
		}
                $paginacionHTML.="</div>";
		return $paginacionHTML;
	}
}//fin class
?>