<?php
/*version 1.3
 * limpieza de filtros
 * El ultimo se encarga del espacio
 * */

class Query {
	private $sql="";
	
	public function __construct(){}
	
	public function select($tabla,$campos = array(), $filtros = array(), $orden = array(), $cantidad = "", $inicio = 0){
		
		$this->sql="SELECT ";
		
		//CAMPOS---------------------------------------------------
		if (count ($campos)>0){
			
			$numCampos=count($campos);
			
			for($i=0;$i<$numCampos;$i++){
				if($i<$numCampos-1){//si no es el ultimo lleva coma
					$this->sql.= "$campos[$i], ";
				}else{
					$this->sql.= "$campos[$i] ";
				}
			}
		}else{
			$this->sql.="* ";
		}
		
		$this->sql.="FROM $tabla ";
		
		
		
		
		//FILTROS---------------------------------------------------
		
		/*	el nombre del campo que se filtrara se denomina nombreFiltro
		 *  y el valor usado para filtrar se llama valorFiltro
		 */
		
		$filtrosLimpios=array();
		if(isset($filtros)){
			$listaFiltros=array_keys($filtros);
				for($i=0;$i<count($listaFiltros);$i++){
					$nombreFiltro=$listaFiltros[$i];
					if($filtros[$nombreFiltro]!==""){
						$filtrosLimpios[$nombreFiltro]=$filtros[$nombreFiltro];
					}
				}
		}
			
		$nombresFiltros=array_keys($filtrosLimpios);
		$numFiltros=count($nombresFiltros);
		
		if ($numFiltros>0){
			$this->sql.="WHERE ( ";
			for($i=0;$i<$numFiltros;$i++){
				$nombreFiltro=$nombresFiltros[$i];
				$valorFiltro=$filtros[$nombreFiltro];//es array asosiativo no numerico
					if($i<$numFiltros-1){//el ultimo no lleva AND
						$this->sql.= "$nombreFiltro = '$valorFiltro' AND ";
					}else{
						$this->sql.= "$nombreFiltro = '$valorFiltro' ";
					}
			}
			$this->sql.=") ";
		}//if num filtros
		
		
		
		//ORDEN---------------------------------------------------
		if(isset ($orden)){
                    $nombresOrden=array_keys($orden);
                    $numOrden=count($nombresOrden);
		
                    if ($numOrden>0){
			$this->sql.="ORDER BY ";
			
			for($i=0;$i<$numOrden;$i++){
				$nombreOrden=$nombresOrden[$i];
				$valorOrden=$orden[$nombreOrden];//es array asosiativo no numerico
				
				if($i<$numOrden-1){//el ultimo no lleva coma
					$this->sql.= "$nombreOrden  $valorOrden, ";
				}else{
					$this->sql.= "$nombreOrden $valorOrden ";
				}				
			}//fin for
                    }//fin if
		}
                
		//LIMIT---------------------------------------------------
		if($cantidad!==""){
			//por defecto inicio es 0 si no se pasa numero
			$this->sql.=" LIMIT $inicio, $cantidad ";
		}
		
	}//fin de select

        public function insert($tabla,$datos){//$datos es un array asi: array("nombreCampo"=>"valor campo",...)
            //print_r($datos);
            $this->sql="INSERT INTO $tabla SET ";
            $nombresCampos=array_keys($datos);
            $numCampos=count($nombresCampos);

            for($i=0;$i<$numCampos;$i++){
		$nombreCampo=$nombresCampos[$i];
		$valorCampo=$datos[$nombreCampo];//es array asosiativo no numerico

		if($i<$numCampos-1){//el ultimo no lleva AND
                    $this->sql.= "$nombreCampo = '$valorCampo', ";
		}else{
                    $this->sql.= "$nombreCampo = '$valorCampo' ";
		}
            }
            //echo $this->obtenerConsultaSQL();
            //$this->sql="INSERT INTO $tabla ";
            //$this->sql.="SET studid=1, name='steve'";
        }

        public function delete($tabla,$campo,$valor){
            $this->sql="DELETE FROM $tabla WHERE $campo = '$valor'";
            //$this->sql="DELETE FROM $tabla WHERE $campo = '$valor' LIMIT 1";
        }

        public function update($tabla, $id, $datos){
            //print_r($id);

            $this->sql="UPDATE $tabla SET ";

            $nombresCampos=array_keys($datos);
            $numCampos=count($nombresCampos);

            for($i=0;$i<$numCampos;$i++){
		$nombreCampo=$nombresCampos[$i];
		$valorCampo=$datos[$nombreCampo];//es array asosiativo no numerico

		if($i<$numCampos-1){//el ultimo no lleva AND
                    $this->sql.= "$nombreCampo = '$valorCampo', ";
		}else{
                    $this->sql.= "$nombreCampo = '$valorCampo' ";
		}
            }

            $nombreFiltro=array_keys($id);
            //solo nos interesa el primer elemento ya que se envia : array("1campo"=>"1valor")
            $this->sql.="WHERE $nombreFiltro[0] = '{$id[$nombreFiltro[0]]}' LIMIT 1" ;
        }

        
	public function obtenerConsultaSQL(){
		return $this->sql;
	}
}





//Ejemplo:
/*
require_once 'ConectorMySQL.class.php';

$campos= array ("Id","Nombre","Tel","Email");
$filtros= array ("Nombre" => "t","Tel"=>9,"Email"=>"a");
$orden= array ("Nombre" => "DESC","Email" => "ASC");

 
$query=new Query();
$query->select("clientes",$campos,$filtros,$orden,4);
echo ($query->obtenerConsultaSQL());


$con=new ConectorMySQL("aquatravelmexico");
$resp=$con->consultar($query->obtenerConsultaSQL());

while (($row = mysql_fetch_array($resp))==true) {
    echo $row["Nombre"]."--";
}
*/
?>