<?php 
/**
* 
*/
class casa_controller
{
	
	public function __construct()
	{
		require_once DIR_MODEL.'/casas/casa_model.php';
		require_once DIR_MODEL.'/idioma/i18n_model.php';
	}

	public function mostrar(){

		if(isset($_REQUEST["filtros"])){
			$filtros = $_REQUEST["filtros"];
		}else{
    		$filtros 				= array();
    		$filtros['id'] 			= "";
    		$filtros['nombre'] 		= "";
    		$filtros['status']		= "";
		}

		if(isset($_REQUEST["pagActual"])){
		 	$pagActual = $_REQUEST["pagActual"];
	  	}else{
		 	$pagActual = "0";
	  	}

	  	$conexionCasa = new casa_model();
	  	$response 	  = $conexionCasa->seleccionar($filtros);

	  	//paginacion------------------------------
	  	$paginacion = new Paginacion(count($response),$pagActual,TAMANO_PAGINA);
  		$paginacion->establecerUrl("./index.php?modulo=casas&controlador=casa&accion=mostrar");
  		$paginacion->agregarFiltros($filtros);
  		$paginacion->establecerVariablePagina("pagActual");
    
	  	$casas = array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());
          
		if(isset($_SESSION['success'])){
    		$success = $_SESSION['success'];
    		unset($_SESSION['success']);
  		}else{
   			$success = "";
  		}
		
	  	require DIR_TEMPLATES.'common/header.tpl';
  		require DIR_TEMPLATES.'casas/casas_tabla.php';
	  	require DIR_TEMPLATES.'common/footer.tpl';
	}

	public function agregar(){
		if($_SERVER['REQUEST_METHOD'] == "POST"){
			$casa   = $_POST['casa'];
			$errors = $this->validate($casa);
			if(count($errors) == 0){
				$conexionCasa = new casa_model();
				$conexionCasa->insertar($casa);
				$_SESSION["success"] = "La casa se agreg&oacute; con exito";
				header('location: ./index.php?modulo=casas&controlador=casa&accion=mostrar');
				exit();
			}
		}else{

			$casa 			   = array();
			$casa['status']    = "";
			$casa['orden']     = "";
			$casa['contenido'] = array();
			$casa['imagenes']  = array();

			$conexionIdiomas   = new i18n_model();
			$idiomas 		   = $conexionIdiomas->seleccionar();

			$i = 0;
			while($fila = mysql_fetch_array($idiomas, MYSQL_ASSOC)){
				$casa['contenido'][$i]['idioma']  	  = $fila['idioma'];
				$casa['contenido'][$i]['id_i18n'] 	  = $fila['id'];
				$casa['contenido'][$i]['nombre']  	  = "";
				$casa['contenido'][$i]['descripcion'] = "";
			}

		}

		require DIR_TEMPLATES.'common/header.tpl';
  		require DIR_TEMPLATES.'casas/casas_form.php';
	  	require DIR_TEMPLATES.'common/footer.tpl';
	}

	public function modificar(){

		if(isset($_GET['id'])){
			$id = $_GET['id'];
		}else{
			header('location: ./index.php?modulo=casas&controlador=casa&accion=mostrar');
			exit();
		}

		$conexionCasa = new casa_model();

		if($_SERVER['REQUEST_METHOD'] == "POST"){
			$casa = $_POST['casa'];
			$errors = $this->validate($casa);
			if(count($errors) == 0){
				$conexionCasa->actualizar($id, $casa);
				$_SESSION["success"] = "La casa se modific&oacute; con exito";
				header('location: ./index.php?modulo=casas&controlador=casa&accion=mostrar');
				exit();
			}
		}else{
			$errors = array();
		}

		$conexionIdiomas = new i18n_model();
		$idiomas = $conexionIdiomas->seleccionar();

		$casa = $conexionCasa->seleccionarPorId($id);

		$i = 0;
		while ($fila = mysql_fetch_array($idiomas, MYSQL_ASSOC)) {
			$casa['contenido'][$i]['idioma']      = $fila["idioma"];
			$casa['contenido'][$i]['id_i18n'] 	  = $fila['id'];
			$tmp = $conexionCasa->seleccionarPorIdIdioma($id, $fila['id']);
			$casa['contenido'][$i]['nombre']  	  = $tmp['nombre'];
			$casa['contenido'][$i]['descripcion'] = $tmp['descripcion'];
			$i++;
		}

		$casa['imagenes'] = $conexionCasa->selecionarImagenes($id);

		require DIR_TEMPLATES.'common/header.tpl';
  		require DIR_TEMPLATES.'casas/casas_form.php';
	  	require DIR_TEMPLATES.'common/footer.tpl';
	}

	public function eliminar(){
		if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
      		header("location:index.php?modulo=casas&controlador=casa&accion=mostrar");
    		exit();
      	}

      	$conexionCasa = new casa_model();
        $conexionCasa->eliminar($_POST["eliminar"]);
        $_SESSION["success"] = "Los elementos seleccionados se han eliminado correctamente.";
        header("location:index.php?modulo=casas&controlador=casa&accion=mostrar");
	}

	public function validate($datas){
		$errors = array();
		return $errors;
	}

}
?>