<?php 
/**
* 
*/
class categoria_controller
{
	
	public function __construct()
	{
		require_once DIR_MODEL.'/casas/categoria_model.php';
    	require_once DIR_MODEL.'/idioma/i18n_model.php';
	}

	public function mostrar(){

		if(isset($_REQUEST["filtros"])){
			$filtros = $_REQUEST["filtros"];
		}else{
    		$filtros 				= array();
    		$filtros['id'] 			= "";
    		$filtros['nombre'] 		= "";
		}

		if(isset($_REQUEST["pagActual"])){
		 	$pagActual = $_REQUEST["pagActual"];
	  	}else{
		 	$pagActual = "0";
	  	}

	  	$conexionCategoria = new categoria_model();
	  	$response 		   = $conexionCategoria->seleccionar($filtros);

	  	//paginacion------------------------------
	  	$paginacion = new Paginacion(count($response),$pagActual,TAMANO_PAGINA);
  		$paginacion->establecerUrl("./index.php?modulo=casas&controlador=categoria&accion=mostrar");
  		$paginacion->agregarFiltros($filtros);
  		$paginacion->establecerVariablePagina("pagActual");
    
	  	$categorias = array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());
          
		if(isset($_SESSION['success'])){
    		$success = $_SESSION['success'];
    		unset($_SESSION['success']);
  		}else{
   			$success = "";
  		}
	
	  	require DIR_TEMPLATES.'common/header.tpl';
  		require DIR_TEMPLATES.'casas/categorias_tabla.php';
	  	require DIR_TEMPLATES.'common/footer.tpl';
	}

	public function agregar(){
		if($_SERVER['REQUEST_METHOD'] == "POST"){
			$categoria = $_POST['categoria'];
			$erros 	   = $this->validate($categoria);
			if(count($erros) == 0){
				$conexionCategoria = new categoria_model();
				$conexionCategoria->insertar($categoria);
				$_SESSION["success"] = "La categoria se creo con exito";
    			header("location:index.php?modulo=casas&controlador=categoria&accion=mostrar");
    			exit();
			}
		}else{
			$categoria 				= array();
			$categoria['status'] 	= 1;
			$categoria['order']	 	= "";
			$categoria['contenido'] = array();

			$conexionIdioma = new i18n_model();
			$idiomas 		= $conexionIdioma->seleccionar();

			$i = 0;
			while ($fila = mysql_fetch_array($idiomas, MYSQL_ASSOC)){
				$categoria["contenido"][$i]["idioma"] 		     = $fila["idioma"];
	            $categoria["contenido"][$i]["id_i18n"] 		     = $fila["id"];
	            $categoria["contenido"][$i]["nombre"]            = "";
	            $categoria["contenido"][$i]["descripcion"]		 = "";
	            $i++;
			}

			$erros = array();
		}

		require DIR_TEMPLATES.'common/header.tpl';
  		require DIR_TEMPLATES.'casas/categorias_form.php';
	  	require DIR_TEMPLATES.'common/footer.tpl';
	}

	public function modificar(){

		if(isset($_GET['id'])){
			$id = $_GET['id'];
		}else{
			header("location:index.php?modulo=casas&controlador=categoria&accion=mostrar");
    		exit();
		}

		$conexionCategoria = new categoria_model();

		if($_SERVER['REQUEST_METHOD'] == "POST"){
			$categoria = $_POST['categoria'];
			$erros = $this->validate($categoria);
			if(count($erros) == 0){
				$conexionCategoria->actualizar($id, $categoria);
				$_SESSION["success"] = "La categoria se modifico con exito";
				header("location:index.php?modulo=casas&controlador=categoria&accion=mostrar");
    			exit();
			}
		}else{
			$erros = array();
		}

		$categoria = $conexionCategoria->seleccionarPorId($id);
		$conexionIdioma = new i18n_model();
		$idiomas = $conexionIdioma->seleccionar();

		$i = 0;
		while ($fila = mysql_fetch_array($idiomas, MYSQL_ASSOC)) {
			$categoria["contenido"][$i]["idioma"] 		     = $fila["idioma"];
	        $categoria["contenido"][$i]["id_i18n"] 		     = $fila["id"];
	        $tmp = $conexionCategoria->seleccionarPorIdIdioma($id, $fila["id"]);
			$categoria["contenido"][$i]["nombre"]            = $tmp['nombre'];
	        $categoria["contenido"][$i]["descripcion"]		 = $tmp['descripcion'];
	        $i++;
		}

		require DIR_TEMPLATES.'common/header.tpl';
  		require DIR_TEMPLATES.'casas/categorias_form.php';
	  	require DIR_TEMPLATES.'common/footer.tpl';

	}

	public function eliminar(){
		if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
      		header("location:index.php?modulo=casas&controlador=categoria&accion=mostrar");
    		exit();
      	}

      	$conexionCategoria = new categoria_model();
        $conexionCategoria->eliminar($_POST["eliminar"]);
        $_SESSION["success"] = "Los elementos seleccionados se han eliminado correctamente.";
        header("location:index.php?modulo=casas&controlador=categoria&accion=mostrar");
	}

	private function validate($datas){
		$erros = array();

		if($datas['contenido'][0]['nombre'] == ""){
			$erros[] = "Ingrese el nombre de la categor&iacute;a.";
		}

		return $erros;
	}

}
?>