<?php
class articulo_controller {
    public function __construct(){
        require_once DIR_MODEL.'/cms/articulo_model.php';
        require_once DIR_MODEL.'/cms/categoria_model.php';
        require_once DIR_MODEL.'/idioma/i18n_model.php';
        require_once DIR_MODEL.'/seo/seo_model.php';
    }
   
    
    public function mostrar(){
    	
    	if($_REQUEST["filtros"]){
    		$filtros=$_REQUEST["filtros"];
    	}else{
    		$filtros 				 = array();
    		$filtros['id'] 			 = "";
    		$filtros['nombre'] 		 = "";
    		$filtros['id_categoria'] = "";
    		$filtros['publicado']    = "";	
    	}
    	
    	if(isset($_REQUEST["pagActual"])){
			$pagActual = $_REQUEST["pagActual"];
		}else{
			$pagActual = "0";
		}
    	
		$conexionArticulo=new articulo_model();
		$response = $conexionArticulo->seleccionar($filtros);
		
		//paginacion------------------------------
		$paginacion=new Paginacion(count($response), $pagActual, TAMANO_PAGINA);
        $paginacion->establecerUrl("./index.php?modulo=cms&controlador=articulo&accion=mostrar");
        $paginacion->agregarFiltros($filtros);
        $paginacion->establecerVariablePagina("pagActual");
        
        $articulos = array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());
        
        
    	if(isset($_SESSION['success'])){
        	$success = $_SESSION['success'];
        	unset($_SESSION['success']);
        }else{
        	$success = "";
        }
        
        //select facil
		$conexionCategoria = new categoria_model();
        $categorias = $conexionCategoria->seleccionar();
        
        require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'cms/articulos_tabla.php';
		require DIR_TEMPLATES.'common/footer.tpl';
    }
    
    
    public function agregar(){
    	
        if($_SERVER['REQUEST_METHOD'] == "POST"){
        	
        	$articulo = $_POST["articulo"];
			        	
        	$errors = $this->validate($articulo);
        	        	
            if(count($errors) == 0){
            	$conexionArticulo=new articulo_model();
            	$conexionArticulo->insertar($articulo);
            	$_SESSION['success'] = "El articulo se creo con exito";
            	header("location:index.php?modulo=cms&controlador=articulo&accion=mostrar");
            	exit();
            }
                	
        }else{
        	           
            //creamos el objeto articulo
            $articulo = array();
            $articulo["contenido"] 	  = array();
            $articulo["id_categoria"] = "";
            $articulo["publicado"]	  = 0;
            $articulo["orden"] 		  = "";
            $categorias				  = $this->categorias();
                        
            //tabs
	        $conexionI18n = new i18n_model();
	        $idiomas = $conexionI18n->seleccionar();
	        $i=0;
	        while($fila = mysql_fetch_array($idiomas, MYSQL_ASSOC)){
	        	$articulo["contenido"][$i]["id_i18n"] 	= $fila["id"];
	            $articulo["contenido"][$i]["idioma"]  	= $fila["idioma"];
	            $articulo["contenido"][$i]["titulo"]    = "";
	            $articulo["contenido"][$i]["contenido"] = "";
	            $articulo["contenido"][$i]["url_seo"]   = "";
	            $articulo["contenido"][$i]["seo_titulo"]   = "";
	            $articulo["contenido"][$i]["meta_description"]   = "";
	            $articulo["contenido"][$i]["meta_keywords"]   = "";
	            $i++;
	        }
        
            $errors = array();
        	       
        }
                	        
        require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'cms/articulo_form.php';
        require DIR_TEMPLATES.'common/footer.tpl';
        		
    }//fin agregar
    
    
	public function modificar(){
        /*Plan:
         * 1) buscar los idiomas
         * 2) crear 1 objeto articulo con tantos contenidos como idiomas existan
         * 3) rellenar los contenidos del objeto
         * 4)regresar el objeto completo
         */
		if(isset($_GET['id'])){
			$id = $_GET['id'];
		}else{
			header("location:index.php?modulo=cms&controlador=articulo&accion=mostrar");
			exit();
		}
		
		if($_SERVER['REQUEST_METHOD'] == "POST"){
			
			$articulo = $_POST['articulo'];
			
			$errors = $this->validate($articulo);
			
			if(count($errors) == 0){
				$conexionArticulo = new articulo_model();
				$conexionArticulo->actualizar($id, $articulo);
				$_SESSION['success'] = "El articulo se modifico conexito";
				header("location:index.php?modulo=cms&controlador=articulo&accion=mostrar");
				exit();
			}
			
		}
		         
         //tabs
         $conexionI18n=new i18n_model();
         $idiomas=$conexionI18n->seleccionar();

         //seleecionamos el articulo
		 $conexionArticulo= new articulo_model();
         $tmp=$conexionArticulo->selecionarPorId($id);
         $articulo=mysql_fetch_array($tmp,MYSQL_ASSOC);
            
		 //creamos el objeto articulo
         $articulo["id_categoria"]	= $articulo["id_categoria"];
         $articulo["publicado"]		= $articulo["publicado"];
         $articulo["orden"] 		= $articulo["orden"];
         $categorias                = $this->categorias();
         
         $i=0;
         
         while($fila=  mysql_fetch_array($idiomas,MYSQL_ASSOC)){
         	$articulo["contenido"][$i]["idioma"]  = $fila["idioma"];
            $articulo["contenido"][$i]["id_i18n"] = $fila["id"];
            $conexionArticulo= new articulo_model();
            $datos=$conexionArticulo->selecionarPorId_e_Idioma($id, $fila["id"]);
            $datos=mysql_fetch_array($datos,MYSQL_ASSOC);
            $articulo["contenido"][$i]["titulo"]	= $datos["titulo"];
            $articulo["contenido"][$i]["contenido"] = $datos["contenido"];
            $articulo["contenido"][$i]["seo_titulo"] = $datos["seo_titulo"];
            $articulo["contenido"][$i]["meta_description"] = $datos["meta_description"];
            $articulo["contenido"][$i]["meta_keywords"] = $datos["meta_keywords"];
			$conexionSEO = new seo_model();
			$articulo["contenido"][$i]["url_seo"] = $conexionSEO->getSeoFromIdAndLanguage("id=".$id, $fila["id"]);
            $i++;
         }
			
		require DIR_TEMPLATES.'common/header.tpl';
		require DIR_TEMPLATES.'cms/articulo_form.php';
		require DIR_TEMPLATES.'common/footer.tpl';
           
    }//fun
    
    
    public function eliminar(){
    	
    	if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
    		header("location:index.php?modulo=cms&controlador=articulo&accion=mostrar");
    		exit();
    	}
    	
		$conexionArticulo=new articulo_model();
        $conexionArticulo->eliminar($_POST["eliminar"]);
        
        $_SESSION['success'] = "Los elementos seleccionados se han eliminado correctamente.";
        header("location:index.php?modulo=cms&controlador=articulo&accion=mostrar");
    }
    
    private function categorias(){
    	 
    	 $conexionCategoria = new categoria_model();
         $cat               = toArray($conexionCategoria->seleccionarPorCatPadre(0));
         $resp              = array();

         foreach ($cat as $value) {
             $resp[] = array('id' => $value['id'], 'nombre' => $value['nombre']);
             $subCat = toArray($conexionCategoria->seleccionarPorCatPadre($value['id']));
             if(count($subCat) > 0){
                foreach ($subCat as $file) {
                    $resp[] = array('id' => $file['id'], 'nombre' => $value['nombre']." > ".$file['nombre']);
                }
             }
         }
                  
         return $resp;
    }
    
    
    private function validate($data){
    	$errors = array();
    	
    	if($data['id_categoria'] == ""){
    		$errors[] = "Selecciones una categoria";
    	}
    	/*
    	if($data['contenido']['titulo'] == ""){
    		$errors[] = "Ingrese un titulo";
    	}
    	
    	if($data['contenido']['contenido'] == ""){
    		$errors[] = "Ingrese contenido";
    	}*/
    	
    	return $errors;
    	
    }
}?>