<?php
/*RESTRICCIONES
 * 1) tiene que existir al menos 1 idioma para poder agregar categorias
 * 2) el numero de categorias que se puede crear esta limitado
 * 3) la categoria 1 no puede eliminarse
 */
class categoria_controller {

    public function __construct(){
        require_once DIR_MODEL.'/cms/categoria_model.php';
        require_once DIR_MODEL.'/idioma/i18n_model.php';
        require_once DIR_MODEL.'/seo/seo_model.php';
    }

    public function mostrar(){
    	
    	if(isset($_REQUEST["filtros"])){
    		$filtros=$_REQUEST["filtros"];
    	}else{
    		$filtros 				            = array();
    		$filtros['id'] 			        = "";
    		$filtros['nombre'] 		      = "";
    		$filtros['orden']           = "";
        $filtros['publicado']       = "";
        $filtros['categoria_padre'] = "";
    	}
    	
    	if(isset($_REQUEST["pagActual"])){
			 $pagActual = $_REQUEST["pagActual"];
		  }else{
			 $pagActual = "0";
		  }
        
		  $conexionCategoria = new categoria_model();
		  $response          = $conexionCategoria->seleccionar($filtros);
	
		//paginacion------------------------------
		  $paginacion = new Paginacion(count($response),$pagActual,TAMANO_PAGINA);
      $paginacion->establecerUrl("./index.php?modulo=cms&controlador=categoria&accion=mostrar");
      $paginacion->agregarFiltros($filtros);
      $paginacion->establecerVariablePagina("pagActual");
        
		  $categorias = array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());

      for($i=0;$i<count($categorias);$i++){
        if($categorias[$i]['categoria_padre'] == 0){
          $categorias[$i]['categoria_padre_nombre'] = "Categor&iacute;a Principal";
        }else{
          $tmp = toArray($conexionCategoria->seleccionarPorIdIdioma($categorias[$i]['categoria_padre'], "1"));
          $categorias[$i]['categoria_padre_nombre'] = $tmp[0]['nombre'];
        }
      }

      $categoriasPadre = $conexionCategoria->seleccionarCategoriasPadre();
      
      //success      
    	if(isset($_SESSION['success'])){
        $success = $_SESSION['success'];
        unset($_SESSION['success']);
      }else{
       	$success = "";
      }

      //error
      if(isset($_SESSION["error"])){
        $error = $_SESSION["error"];
        unset($_SESSION["error"]);
      }else{
        $error = "";
      }
		
		  require DIR_TEMPLATES.'common/header.tpl';
      require DIR_TEMPLATES.'cms/categorias_tabla.php';
		  require DIR_TEMPLATES.'common/footer.tpl';
    }

    public function agregar(){
    	
    	if($_SERVER['REQUEST_METHOD'] == "POST"){
    		
    		$categoria = $_POST['categoria'];  		    		
    		$errors    = $this->validate($categoria);
    		
    		if(count($errors) == 0){
    			$conexionCategoria=new categoria_model();
    			$conexionCategoria->insertar($categoria);
    			$_SESSION["success"] = "La categoria se creo con exito";
    			header("location:index.php?modulo=cms&controlador=categoria&accion=mostrar");
    			exit();
    		}
    		
    	}else{

    		$categoria              = array();
    		$categorias_padre       = $this->getCategoriasPadre();
        $categoria["contenido"] = array();
        $categoria["status"]    = 1;
        $categoria["orden"]     = "";
    		
    		//Generar pestañas
	      $conexionI18n = new i18n_model();
	      $idiomas = $conexionI18n->seleccionar();

    		$i=0;
	        while($fila=  mysql_fetch_array($idiomas,MYSQL_ASSOC)){
	        	  $categoria["contenido"][$i]["idioma"] 		     = $fila["idioma"];
	            $categoria["contenido"][$i]["id_i18n"] 		     = $fila["id"];
	            $categoria["contenido"][$i]["categoria_padre"] = ""; 
	            $categoria["contenido"][$i]["nombre"]          = "";
	            $categoria["contenido"][$i]["descripcion"]     = "";
	            $categoria["contenido"][$i]["url_seo"]     = "";
	            $categoria["contenido"][$i]["seo_titulo"]     = "";
	            $categoria["contenido"][$i]["meta_description"]     = "";
	            $categoria["contenido"][$i]["meta_keywords"]     = "";
	            $i++;
	        }
	        
    		$errors = array();
    	}
        
    	require DIR_TEMPLATES.'common/header.tpl';
      require DIR_TEMPLATES.'cms/categorias_form.php';
      require DIR_TEMPLATES.'common/footer.tpl';
        
    }//fin agregar

      
    public function modificar(){
    	
    	if(isset($_GET["id"])){
    		$id = $_GET["id"];
    	}else{
    		header("location:index.php?modulo=cms&controlador=categoria&accion=mostrar");
    		exit();
    	}
        
    	if($_SERVER['REQUEST_METHOD'] == "POST"){
    		
    		$categoria = $_POST["categoria"];
    		
    		$errors = $this->validate($categoria);
    		
    		if(count($errors) == 0){
    			$conexionCategoria = new categoria_model();
    			$conexionCategoria->actualizar($id, $categoria);
    			$_SESSION["success"] = "La categoria se modifico con exito";
    			header("location:index.php?modulo=cms&controlador=categoria&accion=mostrar");
    			exit();
    		}
    		
    	}
    	
      $conexionCategoria = new categoria_model();
      $categoria         = $conexionCategoria->seleccionarPorId($id);
      $categorias_padre  = $this->getCategoriasPadre($fila["id"]);

		  $conexionI18n      = new i18n_model();
      $idiomas           = $conexionI18n->seleccionar();
        
      $i = 0;

    	while($fila=  mysql_fetch_array($idiomas,MYSQL_ASSOC)){
          $categoria["contenido"][$i]["idioma"]  = $fila["idioma"];
          $categoria["contenido"][$i]["id_i18n"] = $fila["id"];

          $conexionCategoria = new categoria_model();
          $datos = $conexionCategoria->seleccionarPorIdIdioma($id,$fila["id"]);//e idioma
          $datos = mysql_fetch_array($datos,MYSQL_ASSOC);
          $categoria["contenido"][$i]["nombre"] 		     = $datos["nombre"];
          $categoria["contenido"][$i]["descripcion"] 	   = $datos["descripcion"];
          $categoria["contenido"][$i]["seo_titulo"] 	   = $datos["seo_titulo"];
          $categoria["contenido"][$i]["meta_description"] 	   = $datos["meta_description"];
          $categoria["contenido"][$i]["meta_keywords"] 	   = $datos["meta_keywords"];
          
          $conexionSEO              = new seo_model();
          $categoria["contenido"][$i]['url_seo'] = $conexionSEO->getSeoFromIdAndLanguage('root='.$id, $fila["id"]);
          
          $i++;
      }
        	
		  require DIR_TEMPLATES.'common/header.tpl';
		  require DIR_TEMPLATES.'cms/categorias_form.php';
		  require DIR_TEMPLATES.'common/footer.tpl';
            
    }//fun


      public function eliminar(){

      	if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
      		header("location:index.php?modulo=cms&controlador=categoria&accion=mostrar");
    		exit();
      	}
      	
        $conexionCategoria = new categoria_model();

        if($conexionCategoria->eliminar($_POST["eliminar"])){
          $_SESSION["success"] = "Los elementos seleccionados se han eliminado correctamente.";
        }else{
          $_SESSION["error"]   = "No puede eliminar categor&iacute;as con articulos relacionados.";
        }

        header("location:index.php?modulo=cms&controlador=categoria&accion=mostrar");
      }
      
      private function validate($data){
      	
      	$errors = array();
      	
      	if($data['categoria_padre'] == ""){
      		$errors[] = "Seleccione una categoria";
      	}
      	
      	if($data['contenido'][0]['nombre'] == ""){
      		$errors[]= "Ingrese un nombre";
      	}
      	
      	return $errors;
      
      }
      
      private function getCategoriasPadre(){
      	$conexionCategoria = new categoria_model();
      	$cat = toArray($conexionCategoria->seleccionarPorCatPadre(0));
      	return $cat;    	
      	      	
      }
}

?>