<?php
/*RESTRICCIONES
 * 1) tiene que existir al menos 1 idioma para poder agregar categorias
 * 2) el numero de categorias que se puede crear esta limitado
 * 3) la categoria 1 no puede eliminarse
 */
class categoria_controller {

    public function __construct(){
        require_once DIR_MODEL.'/productos/categoria_model.php';
        require_once DIR_MODEL.'/idioma/i18n_model.php';
    }

    public function mostrar(){
    	
    	if(isset($_REQUEST["filtros"])){
    		$filtros=$_REQUEST["filtros"];
    	}else{
    		$filtros 			  = array();
    		$filtros['id'] 		  = "";
    		$filtros['nombre'] 	  = "";
    		$filtros['orden']     = "";
            $filtros['publicado'] = "";
    	}
    	
    	if(isset($_REQUEST["pagActual"])){
			$pagActual = $_REQUEST["pagActual"];
		}else{
			$pagActual = "0";
		}
        
		$conexionCategoria = new categoria_model();
		$response = $conexionCategoria->seleccionar($filtros);
	
		//paginacion------------------------------
		$paginacion = new Paginacion(count($response),$pagActual,TAMANO_PAGINA);
        $paginacion->establecerUrl("./index.php?modulo=productos&controlador=categoria&accion=mostrar");
        $paginacion->agregarFiltros($filtros);
        $paginacion->establecerVariablePagina("pagActual");
        
		$categorias=array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());
        
        //Success
    	if(isset($_SESSION['success'])){
        	$success = $_SESSION['success'];
        	unset($_SESSION['success']);
        }else{
        	$success = "";
        }

        //Error
        if(isset($_SESSION['error'])){
            $error = $_SESSION['error'];
            unset($_SESSION['error']);
        }else{
            $error = "";
        }
        
		require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'productos/categorias_tabla.php';
		require DIR_TEMPLATES.'common/footer.tpl';
    }

    public function agregar(){
    	
    	if($_SERVER['REQUEST_METHOD'] == "POST"){
    		
    		$categoria=$_POST["categoria"];
    		    		
    		$errors = $this->validate($categoria);
    		
    		if (count($errors) == 0){
    			$conexionCategoria=new categoria_model();
    			$conexionCategoria->insertar($categoria);
    			$_SESSION["success"] = "La categoria se creo con exito";
    			header("location:index.php?modulo=productos&controlador=categoria&accion=mostrar");
    			exit();
    		}
    		
    	}else{
    		$categoria              = array();
            $categoria['orden']     = "";
            $categoria['status']    = "";
            $categoria['contenido'] = array();
    		
    		//Generar pestañas
	        $conexionI18n = new i18n_model();
	        $idiomas      = $conexionI18n->seleccionar();
	        
	    	$i=0;
	        while($fila=  mysql_fetch_array($idiomas,MYSQL_ASSOC)){
	        	$categoria['contenido'][$i]["idioma"] = $fila["idioma"];
	            $categoria['contenido'][$i]["id_i18n"] = $fila["id"];
	            $categoria['contenido'][$i]["nombre"] = "";
	            $categoria['contenido'][$i]["descripcion"] = "";
	            $i++;
	        }
    	}
                
        require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'productos/categorias_form.php';
        require DIR_TEMPLATES.'common/footer.tpl';
      
      }//fin agregar

    public function modificar(){
    	
    	if(isset($_GET["id"])){
    		$id = $_GET["id"];
    	}else{
    		header("location:index.php?modulo=productos&controlador=categoria&accion=mostrar");
    		exit();	
    	}
            	
    	if($_SERVER['REQUEST_METHOD'] == "POST"){
    		$categoria = $_POST["categoria"];
    		$errors    = $this->validate($categoria);
    		
    		if (count($errors) == 0){
    			$conexionCategoria = new categoria_model();
    			$conexionCategoria->actualizar($id, $categoria);
    			$_SESSION["success"] = "La categoria se modifico con exito";
    			header("location:index.php?modulo=productos&controlador=categoria&accion=mostrar");
    			exit();
    		}    		
    	}
	
        $conexionI18n = new i18n_model();
        $idiomas      = $conexionI18n->seleccionar();

        $conexionCategoria      = new categoria_model();
        $categoria              = $conexionCategoria->seleccionarPorId($id);
        $categoria['contenido'] = array();
                
        $i=0;
        while($fila = mysql_fetch_array($idiomas,MYSQL_ASSOC)){
        	$categoria['contenido'][$i]["idioma"]  = $fila["idioma"];
            $categoria['contenido'][$i]["id_i18n"] = $fila["id"];           
            $datos = $conexionCategoria->seleccionarPorIdIdioma($id, $fila["id"]);//e idioma
            $categoria['contenido'][$i]["nombre"]      = $datos["nombre"];
            $categoria['contenido'][$i]["descripcion"] = $datos["descripcion"];

            $i++;
        }
                
		require DIR_TEMPLATES.'common/header.tpl';
		require DIR_TEMPLATES.'productos/categorias_form.php';
		require DIR_TEMPLATES.'common/footer.tpl';
            
       
      }//fun


      public function eliminar(){

      		if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
      			header("location:index.php?modulo=productos&controlador=categoria&accion=mostrar");
    			exit();
      		}
      	
            $conexionCategoria = new categoria_model();
            if($conexionCategoria->eliminar($_POST["eliminar"])){
                $_SESSION["success"] = "Los elementos seleccionados se han eliminado correctamente.";
            }else{
                $_SESSION['error'] = "No puede eliminar categorias con productos relacionados.";
            }
            
            header("location:index.php?modulo=productos&controlador=categoria&accion=mostrar");
      }
      
      public function validate($datos){
      	
      	$errors = array();
      	      	      	
      	return $errors;
      	
      }
}

?>