<?php

class producto_controller {

    public function __construct(){
        require_once DIR_MODEL.'/productos/producto_model.php';
        require_once DIR_MODEL.'/productos/categoria_model.php';
        require_once DIR_MODEL.'/idioma/i18n_model.php';
    }

    public function mostrar(){
    	
    	if(isset($_REQUEST["filtros"])){
    		$filtros=$_REQUEST["filtros"];
    	}else{
    		$filtros 				 = array();
    		$filtros['id'] 			 = "";
    		$filtros['nombre'] 		 = "";
    		$filtros['id_categoria'] = "";
    		$filtros['publicado'] 	 = "";		
    	}
    	
    	if(isset($_REQUEST["pagActual"])){
			$pagActual = $_REQUEST["pagActual"];
		}else{
			$pagActual = "0";
		}
        
		$conexionProducto = new producto_model();
		$response = $conexionProducto->seleccionar($filtros);
	
		//paginacion------------------------------
		$paginacion=new Paginacion(count($response),$pagActual,TAMANO_PAGINA);
        $paginacion->establecerUrl("./index.php?modulo=productos&controlador=contenido&accion=mostrar");
        $paginacion->agregarFiltros($filtros);
        $paginacion->establecerVariablePagina("pagActual");
        
		$productos = array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());
       
    	if(isset($_SESSION['success'])){
        	$success = $_SESSION['success'];
        	unset($_SESSION['success']);
        }else{
        	$success = "";
        }
        
        //select facil
        $conexionCategoria = new categoria_model();
        $categorias        = $conexionCategoria->seleccionar();
                
		require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'productos/producto_tabla.php';
		require DIR_TEMPLATES.'common/footer.tpl';
    }

    public function agregar(){
    	
    	if($_SERVER['REQUEST_METHOD'] == "POST"){
    		
    		$producto = $_POST["producto"];
    		    		
    		$errors = $this->validate($producto);
    		
    		if (count($errors) == 0){
    			$conexionProducto = new producto_model();
    			$conexionProducto->insertar($producto);
    			$_SESSION["success"] = "El producto se creo con exito.";
    			header("location:index.php?modulo=productos&controlador=producto&accion=mostrar");
    			exit();
    		}
    		
    	}else{
    		
    		$producto                 = array();
    		$producto["contenido"]    = array();
    		$producto["id_categoria"] = "";
    		$producto["status"] 	  = 0;
    		$producto["orden"]		  = "";
            $producto["tipo"]         = "";
    		$errors = array();
    		
	    	 //Generar pestañas
	        $conexionI18n = new i18n_model();
	        $idiomas      = $conexionI18n->seleccionar(); 
	        
	        $i=0;
	        while($fila=  mysql_fetch_array($idiomas,MYSQL_ASSOC)){
	        	$producto["contenido"][$i]["idioma"]      = $fila["idioma"];
	            $producto["contenido"][$i]["id_i18n"]     = $fila["id"];
	            $producto["contenido"][$i]["nombre"]      = "";
	            $producto["contenido"][$i]["descripcion"] = "";
	            $i++;
	        }
    	}
    	
    	//select Facil
    	$conexionCategoria = new categoria_model();
        $categorias        = $conexionCategoria->seleccionar();
       	       
            
        require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'productos/producto_form.php';
        require DIR_TEMPLATES.'common/footer.tpl';
      
      }//fin agregar
      

    public function modificar(){
    	
    	if(isset($_GET["id"])){
    		$id=$_GET["id"];
    	}else{
    		header("location:index.php?modulo=productos&controlador=producto&accion=mostrar");
    		exit();	
    	}
        
    	
    	if($_SERVER['REQUEST_METHOD'] == "POST"){
    		
    		$producto = $_POST["producto"];
    		
    		$errors = $this->validate($producto);
    		
    		if (count($errors) == 0){
    			$conexionProducto = new producto_model();
    			$conexionProducto->actualizar($id,$producto);
    			$_SESSION["success"] = "El producto se modifico con exito";
    			header("location:index.php?modulo=productos&controlador=producto&accion=mostrar");
    			exit();
    		}
    	    		
    	}
    	
    	//select Facil Categorias
    	$conexionCategoria = new categoria_model();
        $categorias        = $conexionCategoria->seleccionar();
        
        //tabs
        $conexionI18n = new i18n_model();
        $idiomas=$conexionI18n->seleccionar();
        
        //creamos el objeto producto
        $conexionProducto = new producto_model();
        $producto         = $conexionProducto->selecionarPorId($id);
                		                
        $i=0;
        while($fila=  mysql_fetch_array($idiomas,MYSQL_ASSOC)){
        	$producto["contenido"][$i]["idioma"]  = $fila["idioma"];
            $producto["contenido"][$i]["id_i18n"] = $fila["id"];

            $conexionProducto = new producto_model();
            $datos            = $conexionProducto->selecionarPorIdIdioma($id,$fila["id"]);
            $producto["contenido"][$i]["titulo"]    = $datos["titulo"];
            $producto["contenido"][$i]["contenido"] = $datos["contenido"];

            $i++;
        }
       		
		require DIR_TEMPLATES.'common/header.tpl';
		require DIR_TEMPLATES.'productos/producto_form.php';
		require DIR_TEMPLATES.'common/footer.tpl';
            
       
      }//fun


      public function eliminar(){

      		if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
      			header("location:index.php?modulo=productos&controlador=producto&accion=mostrar");
    			exit();
      		}
      	
            $conexionProducto = new producto_model();
            $conexionProducto->eliminar($_POST["eliminar"]);
            $_SESSION["success"] = "Los elementos seleccionados se han eliminado correctamente.";
            header("location:index.php?modulo=productos&controlador=producto&accion=mostrar");
      }
      
      public function validate($datos){
      	
      	$errors = array();
      	
      	if($datos['id_categoria'] == ""){
      		$errors[] = "Seleccione una categor&iacute;a";
      	}
      	      	      	
      	return $errors;
      	
      }
      
}

?>