<?php

class slider_controller{
	
	public function __construct(){
		require_once DIR_MODEL.'/idioma/i18n_model.php';
		require_once DIR_MODEL.'/settings/slider_model.php';
	}
	
	public function mostrar(){
		
		if($_REQUEST["filtros"]){
    		$filtros=$_REQUEST["filtros"];
    	}else{
    		$filtros 				 = array();
    		$filtros['id'] 			 = "";
    		$filtros['nombre'] 		 = "";
    		$filtros['publicado']    = "";	
    	}
    	
		if(isset($_REQUEST["pagActual"])){
			$pagActual = $_REQUEST["pagActual"];
		}else{
			$pagActual = "0";
		}
		
		$conexionSlider = new slider_model();
		$response = $conexionSlider->seleccionar($filtros);
		
		//paginacion------------------------------
		$paginacion=new Paginacion(count($response), $pagActual, TAMANO_PAGINA);
        $paginacion->establecerUrl("./index.php?modulo=settings&controlador=slider&accion=mostrar");
        $paginacion->agregarFiltros($filtros);
        $paginacion->establecerVariablePagina("pagActual");
        
        $slider = array_slice($response, $paginacion->obtenerSiguienteRegistro(), $paginacion->obtenerCantMostrar());
        
		if(isset($_SESSION['success'])){
        	$success = $_SESSION['success'];
        	unset($_SESSION['success']);
        }else{
        	$success = "";
        }
        
        require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'settings/slider_tabla.php';
		require DIR_TEMPLATES.'common/footer.tpl';
		
	}
	
	public function modificar(){
		
		if(isset($_GET['id'])){
			$id = $_GET['id'];
		}else{
			header("location:./index.php?modulo=settings&controlador=slider&accion=mostrar");
			exit();
		}
		
		if($_SERVER['REQUEST_METHOD'] == "POST"){
			$slider = $_POST['slider'];
			
			$errors = $this->validate($slider);
			
			if(count($errors) == 0){
				$conexionSlider = new slider_model();
				$conexionSlider->modificar($id, $slider);
				$_SESSION['success'] = "Los cambios se guardaron con exito";
				header("location:./index.php?modulo=settings&controlador=slider&accion=mostrar");
				exit();
			}
		}
		
		 //tabs
	     $conexionI18n = new i18n_model();
	     $idiomas = toArray($conexionI18n->seleccionar());
	         
	     $conexionSlider = new slider_model();
	     $slider = toArray($conexionSlider->seleccionarPorId($id));
	     $slider['href'] 	  = $slider[0]['href'];
	     $slider['id_target'] = $slider[0]['id_target'];
	     $slider['publicado'] = $slider[0]['publicado'];
	     $slider['orden'] 	  = $slider[0]['orden'];
	         
		 $i = 0;
		 foreach ($idiomas as $fila){
			$slider['contenido'][$i]['idioma'] = $fila['idioma'];
			$slider['contenido'][$i]['id_i18n'] = $fila['id'];
			$conexionSlider = new slider_model();
			$tmp = toArray($conexionSlider->seleccionarPorId_e_Idioma($id, $fila['id']));
			//print_r($tmp);
			$slider['contenido'][$i]['id_imagen']= $tmp[0]['id'];
			$slider['contenido'][$i]['nombre'] 	 = $tmp[0]['nombre'];
			$slider['contenido'][$i]['tipo'] 	 = $tmp[0]['tipo'];
			$i++;
		 }
		 	 
		 require DIR_TEMPLATES.'common/header.tpl';
         require DIR_TEMPLATES.'settings/slider_form.php';
		 require DIR_TEMPLATES.'common/footer.tpl';
	}
	
	public function agregar(){
		
		if($_SERVER['REQUEST_METHOD'] == "POST"){
			$slider = $_POST['slider'];
			$errors = $this->validate($slider);
			
			if(count($errors) == 0){
				$conexionSlider = new slider_model();
				$conexionSlider->insertar($slider);
				$_SESSION['success'] = "El slider se creo con exito";
				header("location:./index.php?modulo=settings&controlador=slider&accion=mostrar");
				exit();
			}	
		}

		$slider 			 = array();
		$slider['contenido'] = array();			
		$slider['href'] 	 = "";
		$slider['id_target'] = "";
		$slider['orden'] 	 = "";
		$slider['publicado'] = "";
		$errors 			 = array();
			
		//tabs
        $conexionI18n = new i18n_model();
        $idiomas 	  = toArray($conexionI18n->seleccionar());

        $i=0;    
        foreach ($idiomas as $fila){
        	$slider['contenido'][$i]['idioma']   = $fila['idioma'];
        	$slider['contenido'][$i]['id_i18n']  = $fila['id'];
        	$slider['contenido'][$i]['nombre']   = "";
        	$slider['contenido'][$i]['id_image'] = "";
        	$i++;
        }
		
		require DIR_TEMPLATES.'common/header.tpl';
        require DIR_TEMPLATES.'settings/slider_form.php';
		require DIR_TEMPLATES.'common/footer.tpl';	
	}
	
	public function eliminar(){
		
		if(!isset($_POST['eliminar']) || !is_array($_POST['eliminar'])){
    		header("location:index.php?modulo=settings&controlador=slider&accion=mostrar");
    		exit();
    	}
    	
    	$conexionSlider = new slider_model();
    	$conexionSlider->eliminar($_POST['eliminar']);
    	
    	$_SESSION['success'] = "Los elementos seleccionados se han eliminado correctamente.";
        header("location:index.php?modulo=settings&controlador=slider&accion=mostrar");
	}
	
	private function validate($data){
		
		$errors = array();
		
		if($data['publicado'] == ""){
			$errors[] = "Seleccione un estatus por favor";
		}
		
		if($data['contenido'][0]['nombre'] == ""){
			$errors[] = "Ingrese un nombre por favor";
		}
		
		return $errors;
		
	}
	
}

?>