<?php
class articulo_model {

    public function seleccionar($filtros=array(),$cantidad="",$inicio=""){

        $sql="SELECT art.*,
                    idi.titulo AS titulo, idi.contenido AS contenido,
                    cat.nombre AS categoria
                FROM cms_articulos art
                LEFT JOIN cms_articulos_i18n idi ON (art.id = idi.id_articulo AND idi.id_i18n=1)
                LEFT JOIN cms_categorias_i18n cat ON (art.id_categoria = cat.id_categoria AND cat.id_i18n=1)
            ";

        $filtrosLimpios=array();

        if($filtros ['id'] != "" )          {$filtrosLimpios[]="art.id          ='{$filtros ['id']}' AND ";}
        if($filtros ['nombre'] != "" )      {$filtrosLimpios[]="idi.titulo      ='{$filtros ['nombre']}' AND ";}
        if($filtros ['id_categoria'] != "" ) {$filtrosLimpios[]="art.id_categoria ='{$filtros ['id_categoria']}' AND ";}
        if($filtros ['publicado'] != "" ) {$filtrosLimpios[]="art.publicado ='{$filtros ['publicado']}' AND ";}

        if(count($filtrosLimpios) >0){
            $cad_filtro ="WHERE ( ";
            foreach($filtrosLimpios as $filtroTmp){
                $cad_filtro .=$filtroTmp;
            }
            $pos   = strripos($cad_filtro, "AND");
            $cad_filtro=substr_replace ( $cad_filtro, " ", $pos);
            $cad_filtro .=" )";
        }
        $sql.=$cad_filtro;

        $sql.=" ORDER BY art.id DESC";

        if($cantidad!==""){
            //por defecto inicio es 0 si no se pasa numero
            $sql.=" LIMIT $inicio, $cantidad ";
		}

        
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp;
    }

    public function insertar($datos){
                        
        $contenido=$datos["contenido"];
        unset ($datos["contenido"]);//el obj query es dependiente de los arrays asociativos y no puede tener arrays
		        
        $query=new Query();
        //datos---------------
        $datos["fecha_creacion"]= date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_creacion"]= $_SESSION['usuario']['id'];
                
        $query->insert("cms_articulos", $datos);
        $sql=$query->obtenerConsultaSQL();
        //echo $sql;
        $resp=$this->ejecutarConsulta($sql);

        $id_articulo=mysql_insert_id();
        
        foreach ($contenido as $tmp){
            //agregamos al array
            unset($tmp["idioma"]);
            $tmp["id_articulo"]=$id_articulo;

            $url_seo = $tmp['url_seo'];
            unset($tmp['url_seo']);
            
            $query=new Query();
            $query->insert("cms_articulos_i18n", $tmp);
            $sql=$query->obtenerConsultaSQL();
            //echo $sql;
            $this->ejecutarConsulta($sql);
            
             /**Insertar los datos SEO del articulo**/
            $sql = "INSERT INTO seo_encode SET
                                        id_i18n    = '{$tmp["id_i18n"]}',
                                        url        = 'id={$id_articulo}',
                                        nombre_seo = '{$url_seo}'";

            $this->ejecutarConsulta($sql);
        }
        
        return $resp;
    }

    public function eliminar($datos=array()){
        
        for($i=0;$i<=count($datos);$i++){
            if($datos[$i] != 1){
                $query=new Query();
                $query->delete("cms_articulos", "id", $datos[$i]);
                $sql= $query->obtenerConsultaSQL();
                $resp=$this->ejecutarConsulta($sql);

                $query=new Query();
                $query->delete("cms_articulos_i18n", "id_articulo", $datos[$i]);
                $sql= $query->obtenerConsultaSQL();
                $this->ejecutarConsulta($sql);
            }
        }
        return $resp;
    }


    public function selecionarPorId($id){
        $sql="SELECT * FROM cms_articulos WHERE id='$id'";
        $resp=$this->ejecutarConsulta($sql);
        return $resp;
    }

    public function selecionarPorId_e_Idioma($id,$id_idioma){
        $sql="SELECT * FROM cms_articulos_i18n WHERE (id_articulo='$id' AND id_i18n='$id_idioma')";
        $resp=$this->ejecutarConsulta($sql);
        return $resp;
    }

    public function actualizar($id,$datos){
		
        $contenido=$datos["contenido"];
        unset ($datos["contenido"]);
        
        $query=new Query();
        $datos["fecha_modificacion"]= date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_modificacion"]= $_SESSION['usuario']['id'];

        $id_articulo=array("id"=>$id);
        $query->update("cms_articulos", $id_articulo, $datos);
        $sql=$query->obtenerConsultaSQL();
        $resp=$this->ejecutarConsulta($sql);

         //TABLA cms_categorias_i18n------------
        
        foreach ($contenido as $tmp){
        	
        	unset($tmp["idioma"]);

            //ver si existe
            $sql="SELECT * FROM cms_articulos_i18n
                  WHERE ( id_articulo = '{$id}' and id_i18n ='{$tmp["id_i18n"]}')";

            $resp     = $this->ejecutarConsulta($sql);
            $cantResp = mysql_num_rows($resp);

            if($cantResp==0){
                //id 	id_articulo 	id_i18n 	titulo 	contenido
                $sql="INSERT INTO cms_articulos_i18n SET
                                                    id_articulo = '{$id}',
                                                    id_i18n     = '{$tmp["id_i18n"]}',
                									titulo      = '{$tmp["titulo"]}',
                                                	contenido   = '{$tmp["contenido"]}',
                                                	seo_titulo='{$tmp["seo_titulo"]}',
                                                	meta_description='{$tmp["meta_description"]}',
                                                	meta_keywords='{$tmp["meta_keywords"]}'";
                

            }else{
                $sql="UPDATE  cms_articulos_i18n SET    
                								titulo='{$tmp["titulo"]}',
                                                contenido='{$tmp["contenido"]}',
                                                seo_titulo='{$tmp["seo_titulo"]}',
                                                meta_description='{$tmp["meta_description"]}',
                                                meta_keywords='{$tmp["meta_keywords"]}'
                                                WHERE (id_articulo = '$id' AND id_i18n ='{$tmp["id_i18n"]}')";
            }
            
            $this->ejecutarConsulta($sql);
            
            /**Actualizar los datos seo**/
            $sql  = "SELECT * FROM seo_encode WHERE (id_i18n = '{$tmp["id_i18n"]}' AND url = 'id={$id}')";
            $resp = $this->ejecutarConsulta($sql);
            if(mysql_num_rows($resp) == 0){
                $sql = "INSERT INTO seo_encode SET
                                        id_i18n    = '{$tmp["id_i18n"]}',
                                        url        = 'id={$id}',
                                        nombre_seo = '{$tmp["url_seo"]}'";
            }else{
                $sql = "UPDATE seo_encode SET
                                            nombre_seo = '{$tmp["url_seo"]}'
                                        WHERE(id_i18n = '{$tmp["id_i18n"]}' AND url = 'id={$id}')";
            }

            $this->ejecutarConsulta($sql);
        }
        
    }
	
    public function ejecutarConsulta($sql){
        $conector=new ConectorMySQL(MYSQL_BD,MYSQL_HOST,MYSQL_USER,MYSQL_PASSWORD);
        $resp=$conector->consultar($sql);
        //$conector->desconectar();
        return $resp;
    }
}
?>