<?php
/*RESTRICCIONES
 * 1) no se puede eliminar una categoria si tiene algun articulo
 * 2) no se puede eliminar la categoria con id 1
 */

class categoria_model {
    
    public function seleccionar($filtros=array(),$cantidad="",$inicio=""){

        $sql="SELECT cat.*,
                    idi.nombre AS nombre, idi.descripcion AS descripcion
                FROM cms_categorias cat
                LEFT JOIN cms_categorias_i18n idi ON (cat.id = idi.id_categoria AND idi.id_i18n=1)
            ";

        $filtrosLimpios=array();

        if($filtros ['id']        != "" )      {$filtrosLimpios[] = "cat.id              = '{$filtros ['id']}' AND ";}
        if($filtros ['nombre']    != "" )      {$filtrosLimpios[] = "idi.nombre          = '{$filtros ['nombre']}' AND ";}
        if($filtros['categoria_padre'] != "" ) {$filtrosLimpios[] = "cat.categoria_padre = '{$filtros ['categoria_padre']}' AND ";}
        if($filtros ['orden']     != "" )      {$filtrosLimpios[] = "cat.orden           = '{$filtros ['orden']}' AND ";}
        if($filtros ['publicado'] != "" )      {$filtrosLimpios[] = "cat.status          = '{$filtros ['publicado']}' AND ";}

        if(count($filtrosLimpios) >0){
            $cad_filtro ="WHERE ( ";
            foreach($filtrosLimpios as $filtroTmp){
                $cad_filtro .=$filtroTmp;
            }
            $pos   = strripos($cad_filtro, "AND");
            $cad_filtro=substr_replace ( $cad_filtro, " ", $pos);
            $cad_filtro .=" )";
        }
        $sql.=$cad_filtro;

        $sql.=" ORDER BY cat.id DESC";

        if($cantidad!==""){
            //por defecto inicio es 0 si no se pasa numero
            $sql.=" LIMIT $inicio, $cantidad ";
	    }

        //echo $sql;
        $resp= toArray($this->ejecutarConsulta($sql));
        return $resp;
        
    }

    public function seleccionarPorId($id){
        $sql  = "SELECT * FROM cms_categorias WHERE(id='{$id}')";
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp[0];
    }

    public function seleccionarCategoriasPadre(){
        $sql = "SELECT 
                    c.id, 
                    idi.nombre AS nombre
                FROM cms_categorias c
                LEFT JOIN cms_categorias_i18n idi
                ON(c.id = idi.id_categoria AND idi.id_i18n = 1)
                ORDER BY c.orden";
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp;
    }

    //aqui me quede  
    public function seleccionarPorIdIdioma($id,$idioma){
        $sql="SELECT
                c.id AS id_categoria,
                idi.nombre,
                idi.descripcion,
                idi.seo_titulo,
                idi.meta_description,
                idi.meta_keywords,
                c.categoria_padre
             FROM cms_categorias c
             LEFT JOIN cms_categorias_i18n idi
             ON(c.id = idi.id_categoria AND idi.id_i18n = '{$idioma}')
             WHERE (c.id = $id)";

        $resp=$this->ejecutarConsulta($sql);
        return $resp;
    }

    public function obtenerArticulos($id){
        $sql="SELECT * FROM cms_articulos WHERE id_categoria= '$id'";
        $resp=$this->ejecutarConsulta($sql);
        return $resp;
    }
    
    public function seleccionarPorCatPadre($catPadre){
    	$sql = "SELECT c.id, idi.nombre 
                FROM cms_categorias c
                LEFT JOIN cms_categorias_i18n idi 
                ON(c.id = idi.id_categoria AND idi.id_i18n = 1)
                WHERE (c.categoria_padre = '{$catPadre}' AND c.status = 1)";
    	$resp = $this->ejecutarConsulta($sql);
    	return $resp;
    }

    public function insertar($datos){

        //TABLA cms_categorias-----------------
        $contenido = array();
        $contenido = $datos['contenido'];
        unset($datos['contenido']);

        $datos["fecha_creacion"]= date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_creacion"]= $_SESSION['usuario']['ida'];

        $query=new Query();
        $query->insert("cms_categorias", $datos);
        $sql=$query->obtenerConsultaSQL();
        
        $this->ejecutarConsulta($sql);

        //TABLA cms_categorias_i18n------------
        $id_categoria = mysql_insert_id();
        
        foreach ($contenido as $tmp){
            //agregamos al array
            unset($tmp["idioma"]);
            
            $tmp["id_categoria"]=$id_categoria;
            
            $url_seo = $tmp['url_seo'];
            unset($tmp['url_seo']);
                        
            $query=new Query();
            $query->insert("cms_categorias_i18n", $tmp);
            $sql=$query->obtenerConsultaSQL();
            $this->ejecutarConsulta($sql);
            
            /*Guardar los datos seo de la nueva categoria*/
            $sql = "INSERT INTO seo_encode SET
			id_i18n    = '{$tmp["id_i18n"]}',
			url        = 'root={$id_categoria}',
			nombre_seo = '{$url_seo}'";

            $this->ejecutarConsulta($sql);
        }
    }

    public function eliminar($datos=array()){
        $flag = true;
    	for($i=0; $i<count($datos);$i++){
           $cantArticulos = mysql_num_rows($this->obtenerArticulos($datos[$i]));
            if($cantArticulos == 0){
            	$query = new Query();
                $query->delete("cms_categorias", "id", $datos[$i]);
                $sql   = $query->obtenerConsultaSQL();
                $this->ejecutarConsulta($sql);

                $query = new Query();
                $query->delete("cms_categorias_i18n", "id_categoria", $datos[$i]);
                $sql   = $query->obtenerConsultaSQL();
                $this->ejecutarConsulta($sql);
            }else{
                $flag = false;
            }
        }

        return $flag;
    }

    public function actualizar($id,$datos){
        $contenido = $datos['contenido'];
        unset($datos['contenido']);

        $query = new Query();
        //datos---------------
        $datos["fecha_modificacion"]      = date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_modificacion"] = $_SESSION['usuario']['ida'];

        $id_categoria = array("id" => $id);
        $query->update("cms_categorias", $id_categoria, $datos);
        $sql = $query->obtenerConsultaSQL();
        $this->ejecutarConsulta($sql);
        
        //TABLA cms_categorias_i18n------------
        $id_categoria = mysql_insert_id();

        foreach ($contenido as $tmp){
        	
            unset($tmp['idioma']);
            //ver si el idioma ya existe en la categoria
            $sql  = "SELECT * FROM cms_categorias_i18n WHERE(id_i18n ='{$tmp["id_i18n"]}' AND id_categoria = '{$id}' )";
            $resp = $this->ejecutarConsulta($sql);
            $cantResp = mysql_num_rows($resp);
            
            if($cantResp == 0){
                $sql = "INSERT INTO cms_categorias_i18n SET
                									  id_categoria    = '$id',
                									  id_i18n	      = '{$tmp["id_i18n"]}', 
                									  nombre	      = '{$tmp["nombre"]}',
                									  descripcion     = '{$tmp["descripcion"]}',
                									  seo_titulo='{$tmp["seo_titulo"]}',
		                                              meta_description='{$tmp["meta_description"]}',
		                                              meta_keywords='{$tmp["meta_keywords"]}'";
                
            }else{
                $sql = "UPDATE  cms_categorias_i18n SET 
                							       nombre          = '{$tmp["nombre"]}', 
                							       descripcion     = '{$tmp["descripcion"]}',
                							       seo_titulo='{$tmp["seo_titulo"]}',
                                                	meta_description='{$tmp["meta_description"]}',
                                                	meta_keywords='{$tmp["meta_keywords"]}'
                							       WHERE (id_i18n  = '{$tmp["id_i18n"]}' AND id_categoria = '{$id}')";
            }

            $this->ejecutarConsulta($sql);
            
            //Modificar los datos seo de la categoria
            $sql  = "SELECT * FROM seo_encode WHERE(id_i18n = '{$tmp["id_i18n"]}' AND url = 'root={$id}')";
            $resp = $this->ejecutarConsulta($sql);
            if(mysql_num_rows($resp) == 0){
                $sql = "INSERT INTO seo_encode SET
                                        id_i18n    = '{$tmp["id_i18n"]}',
                                        url        = 'root={$id}',
                                        nombre_seo = '{$tmp["url_seo"]}'";
            }else{
                 $sql = "UPDATE seo_encode SET 
                                            nombre_seo = '{$tmp["url_seo"]}' 
                                        WHERE(id_i18n = '{$tmp["id_i18n"]}' AND url ='root=".$id."')";
            }

            $this->ejecutarConsulta($sql);
            
        }
    }

    public function contarTotalCategorias(){
        return mysql_num_rows($this->seleccionar());
    }
    
    private function ejecutarConsulta($sql){
        $conector=new ConectorMySQL(MYSQL_BD,MYSQL_HOST,MYSQL_USER,MYSQL_PASSWORD);
        $resp=$conector->consultar($sql);
        //$conector->desconectar();
        return $resp;
    }

}
?>
