<?php
/*RESTRICCIONES
 * 1) no se puede eliminar una categoria si tiene algun articulo
 * 2) no se puede eliminar la categoria con id 1
 */

class categoria_model {
    
    public function seleccionar($filtros=array(),$cantidad="",$inicio=""){

        $sql="SELECT cat.*,
                    idi.nombre AS nombre, idi.descripcion AS descripcion
                FROM producto_categorias cat
                LEFT JOIN producto_categorias_i18n idi ON (cat.id = idi.id_categoria AND idi.id_i18n=1)
            ";

        $filtrosLimpios=array();

        if($filtros ['id']         != "" ) {$filtrosLimpios[] = "cat.id     = '{$filtros ['id']}' AND ";}
        if($filtros ['nombre']     != "" ) {$filtrosLimpios[] = "idi.nombre = '{$filtros ['nombre']}' AND ";}
        if($filtros ['orden']      != "" ) {$filtrosLimpios[] = "cat.orden  = '{$filtros ['orden']}' AND ";}
        if($filtros ['publicado']  != "" ) {$filtrosLimpios[] = "cat.status = '{$filtros ['publicado']}' AND ";}

        if(count($filtrosLimpios) >0){
            $cad_filtro ="WHERE ( ";
            foreach($filtrosLimpios as $filtroTmp){
                $cad_filtro .=$filtroTmp;
            }
            $pos   = strripos($cad_filtro, "AND");
            $cad_filtro=substr_replace ( $cad_filtro, " ", $pos);
            $cad_filtro .=" )";
        }
        $sql.=$cad_filtro;
        $sql.= " ORDER BY cat.orden DESC";

        if($cantidad!==""){
            //por defecto inicio es 0 si no se pasa numero
            $sql.=" LIMIT $inicio, $cantidad ";
	    }
        
        $resp= toArray($this->ejecutarConsulta($sql));
        return $resp;
        
    }

    //aqui me quede  
    public function seleccionarPorId($id){
        $sql = "SELECT * 
                FROM producto_categorias
                WHERE (id = '{$id}')";
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp[0];
    }

    public function seleccionarPorIdIdioma($id, $idioma){
        $sql = "SELECT
                    cat.*,
                    idi.nombre AS nombre,
                    idi.descripcion AS descripcion
                FROM producto_categorias cat
                LEFT JOIN producto_categorias_i18n idi
                ON(cat.id = idi.id_categoria AND idi.id_i18n = '{$idioma}')
                WHERE(cat.id = '{$id}')";

        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp[0];
    }

    public function insertar($datos){
		
        $contenido = $datos["contenido"];
        unset($datos["contenido"]);

        //TABLA cms_categorias-----------------

        if(isset($_FILES['product_category_img'])){
            $upload = new Upload($_FILES['product_category_img']);   
        }

        $datos["fecha_creacion"]      = date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_creacion"] = $_SESSION['usuario']['id'];

        $query = new Query();
        $query->insert("producto_categorias", $datos);
        $sql   = $query->obtenerConsultaSQL();
        
        $this->ejecutarConsulta($sql);

        //TABLA cms_categorias_i18n------------
        $id_categoria = mysql_insert_id();
        
        foreach ($contenido as $tmp){
        	//quitamos el nombre del idioma del array
        	unset($tmp["idioma"]);
        	
            //agregamos al array
            $tmp["id_categoria"]=$id_categoria;
            
            $query = new Query();
            $query->insert("producto_categorias_i18n", $tmp);
            $sql   = $query->obtenerConsultaSQL();
            $this->ejecutarConsulta($sql);
        }

        //Insertar la imagen
        if(isset($_FILES['product_category_img'])){
            $this->uploadImage($id_categoria, $upload);  
        }
    }

    public function eliminar($datos=array()){
       $flag = true;
       for($i=0; $i<count($datos);$i++){
           $cantProductos = $this->obtenerProductos($datos[$i]);
            if($cantProductos == 0){
                $this->deleteImage($datos[$i]);
                
            	$query=new Query();
                $query->delete("producto_categorias", "id", $datos[$i]);
                $sql= $query->obtenerConsultaSQL();
                $this->ejecutarConsulta($sql);

                $query=new Query();
                $query->delete("producto_categorias_i18n", "id_categoria", $datos[$i]);
                $sql= $query->obtenerConsultaSQL();
                $this->ejecutarConsulta($sql);
            }else{
                $flag = false;
            }
        }

        return $flag;
    }

    public function actualizar($id, $datos){

        $contenido = $datos['contenido'];
        unset($datos['contenido']);

        //TABLA cms_categorias ------------
        if(isset($_FILES['product_category_img'])){
            $upload = new Upload($_FILES['product_category_img']);
        }

        $datos['fecha_modificacion']      = date("Y-n-j G:i:s");
        $datos['id_usuario_modificacion'] = $_SESSION['usuario']['id'];

        $sql = "UPDATE producto_categorias SET
                                            orden                   = '{$datos['orden']}',
                                            status                  = '{$datos['status']}',
                                            fecha_modificacion      = '{$datos['fecha_modificacion']}',
                                            id_usuario_modificacion = '{$datos['id_usuario_modificacion']}'
                                            WHERE(id = '{$id}')";
        $this->ejecutarConsulta($sql);
        
        //TABLA cms_categorias_i18n------------
        foreach ($contenido as $tmp){
        	unset($tmp['idioma']);
            
            //ver si el idioma ya existe en la categoria
            $sql="SELECT * FROM producto_categorias_i18n WHERE ( id_i18n ='{$tmp["id_i18n"]}' AND id_categoria = '$id' )";
            $cantResp = mysql_num_rows($this->ejecutarConsulta($sql));
            
            if($cantResp==0){
                $sql="INSERT INTO producto_categorias_i18n SET 
                									  id_categoria = '{$id}' , 
                									  id_i18n	   = '{$tmp["id_i18n"]}', 
                									  nombre	   = '{$tmp["nombre"]}', 
                									  descripcion  = '{$tmp["descripcion"]}' ";
                
            }else{
                $sql="UPDATE  producto_categorias_i18n SET 
                								nombre='{$tmp["nombre"]}', 
                								descripcion='{$tmp["descripcion"]}' 
                		WHERE ( id_i18n ='{$tmp["id_i18n"]}' AND id_categoria = '$id' ) ";
            }
            
            $this->ejecutarConsulta($sql);
        }

        //Insertar la imagen
        if(isset($_FILES['product_category_img'])){
            $this->deleteImage($id);
            if($upload->obtenerExtUpload() != ""){
                $this->uploadImage($id, $upload);
            }
        }
    }

    public function contarTotalCategorias(){
        return mysql_num_rows($this->seleccionar());
    }

    private function obtenerProductos($id_categoria){
        $sql  = "SELECT * FROM producto_cont WHERE(id_categoria = '{$id_categoria}')";
        $resp = $this->ejecutarConsulta($sql);
        return mysql_num_rows($resp);
    }

    /*********operaciones con imagenes**********/

    private function uploadImage($id, $upload){
         $upload->renombrar($id);
         $upload->guardarEn(DIR_FILES."productos/categorias");
        
         $original = DIR_FILES."productos/categorias/".$id.".".$upload->obtenerExtUpload();
         $mini     = DIR_FILES."productos/categorias/".$id."_80x80.".$upload->obtenerExtUpload();
         $thumb    = new imagenMiniatura($original,$mini);
         $thumb->crear(ANCHO_THUMB_1,ALTO_THUMB_1);

          $sql = "UPDATE producto_categorias SET tipo = '".$upload->obtenerExtUpload()."' WHERE(id = '{$id}')";
          $this->ejecutarConsulta($sql);
    }

    private function deleteImage($id){
        $resp = $this->seleccionarPorId($id);
        
        @unlink(DIR_FILES."productos/categorias/".$resp['id'].".".$resp['tipo']);
        @unlink(DIR_FILES."productos/categorias/".$resp['id']."_80x80.".$resp['tipo']);

        $sql = "UPDATE producto_categorias SET tipo = '' WHERE(id = '{$id}')";
        $this->ejecutarConsulta($sql);  
    }

    private function ejecutarConsulta($sql){
        $conector=new ConectorMySQL(MYSQL_BD,MYSQL_HOST,MYSQL_USER,MYSQL_PASSWORD);
        $resp=$conector->consultar($sql);
        //$conector->desconectar();
        return $resp;
    }

}
?>
