<?php
class producto_model {

    public function seleccionar($filtros=array(),$cantidad="",$inicio=""){

        $sql="SELECT pro.*,
                    idi.titulo AS titulo, idi.contenido AS contenido,
                    cat.nombre AS categoria
                FROM producto_cont pro
                LEFT JOIN producto_cont_i18n idi ON (pro.id = idi.id_producto AND idi.id_i18n=1)
                LEFT JOIN producto_categorias_i18n cat ON (pro.id_categoria = cat.id_categoria AND cat.id_i18n=1)
            ";

        $filtrosLimpios=array();

        if($filtros ['id'] != "" )           {$filtrosLimpios[]="pro.id           ='{$filtros ['id']}' AND ";}
        if($filtros ['nombre'] != "" )       {$filtrosLimpios[]="idi.titulo       ='{$filtros ['nombre']}' AND ";}
        if($filtros ['id_categoria'] != "" ) {$filtrosLimpios[]="pro.id_categoria ='{$filtros ['id_categoria']}' AND ";}
        if($filtros ['publicado'] != "" ) 	 {$filtrosLimpios[]="pro.publicado    ='{$filtros ['publicado']}' AND ";}

        if(count($filtrosLimpios) >0){
            $cad_filtro ="WHERE ( ";
            foreach($filtrosLimpios as $filtroTmp){
                $cad_filtro .=$filtroTmp;
            }
            $pos   = strripos($cad_filtro, "AND");
            $cad_filtro=substr_replace ( $cad_filtro, " ", $pos);
            $cad_filtro .=" )";
        }
        $sql.=$cad_filtro;

        if($cantidad!==""){
            //por defecto inicio es 0 si no se pasa numero
            $sql.=" LIMIT $inicio, $cantidad ";
		}

        
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp;
    }

    public function insertar($datos){

    	$contenido = $datos["contenido"];
        unset ($datos["contenido"]);//el obj query es dependiente de los arrays asociativos y no puede tener arrays
		                
        $query = new Query();
        //datos---------------
        $datos["fecha_creacion"]      = date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_creacion"] = $_SESSION['usuario']['id'];
                
        $query->insert("producto_cont", $datos);
        $sql  = $query->obtenerConsultaSQL();
        $this->ejecutarConsulta($sql);

        $id_producto = mysql_insert_id();
        
        foreach ($contenido as $tmp){
            //agregamos al array
            unset($tmp["idioma"]);
            $tmp["id_producto"] = $id_producto;

            $query = new Query();
            $query->insert("producto_cont_i18n", $tmp);
            $sql   = $query->obtenerConsultaSQL();
            $this->ejecutarConsulta($sql);
        }

        if(isset($_FILES['product_image'])){
            $upload = new Upload($_FILES['product_image']);
            $this->uploadImage($id_producto, $upload);
        }
        
        return $resp;
    }

    public function eliminar($datos=array()){
        
        for($i=0;$i<=count($datos);$i++){
                
                $this->deleteImage($datos[$i]);

                $query=new Query();
                $query->delete("producto_cont", "id", $datos[$i]);
                $sql= $query->obtenerConsultaSQL();
                $resp=$this->ejecutarConsulta($sql);

                $query=new Query();
                $query->delete("producto_cont_i18n", "id_producto", $datos[$i]);
                $sql= $query->obtenerConsultaSQL();
                $this->ejecutarConsulta($sql);
           
        }
        return $resp;
    }


    public function selecionarPorId($id){
        $sql  = "SELECT * FROM producto_cont WHERE id = '$id'";
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp[0];
    }

    public function selecionarPorIdIdioma($id, $id_idioma){
        $sql  = "SELECT * FROM producto_cont_i18n WHERE (id_producto = '$id' AND id_i18n = '$id_idioma')";
        $resp = toArray($this->ejecutarConsulta($sql));
        return $resp[0];
    }

    public function actualizar($id,$datos){
		
        $contenido = $datos["contenido"];
        unset ($datos["contenido"]);
        
        //TABLA productos_cont------------
        $query = new Query();
        $datos["fecha_modificacion"]      = date("Y-n-j G:i:s");//2010-12-31 23:20:15
        $datos["id_usuario_modificacion"] = $_SESSION['usuario']['id'];

        $id_producto = array("id"=>$id);
        $query->update("producto_cont", $id_producto, $datos);
        $sql  = $query->obtenerConsultaSQL();
        $this->ejecutarConsulta($sql);

        //TABLA productos_cont_i18n------------
        foreach ($contenido as $tmp){
            $sql = "SELECT * FROM producto_cont_i18n
                    WHERE ( id_i18n ='{$tmp["id_i18n"]}'AND id_producto = '{$id}')";
            $resp     = $this->ejecutarConsulta($sql);
            $cantResp = mysql_num_rows($resp);
            
            if($cantResp == 0){
                //id 	id_articulo 	id_i18n 	titulo 	contenido
                $sql="INSERT INTO producto_cont_i18n SET 
                                                    id_articulo = '{$id}',
                                                    id_i18n     = '{$tmp["id_i18n"]}',
                									titulo      = '{$tmp["titulo"]}',
                                                	contenido   = '{$tmp["contenido"]}'";
            }else{
                $sql="UPDATE  producto_cont_i18n SET    
                								titulo='{$tmp["titulo"]}',
                                                contenido='{$tmp["contenido"]}'
                                                WHERE ( id_i18n ='{$tmp["id_i18n"]}' AND id_producto = '$id')";
            }
            $this->ejecutarConsulta($sql);
        }

        if(isset($_FILES['product_image'])){
            $this->deleteImage($id);
            $upload = new Upload($_FILES['product_image']);
            $this->uploadImage($id, $upload);
        }
        
    }

    /*********operaciones con imagenes**********/
    private function uploadImage($id, $upload){
         $upload->renombrar($id);
         $upload->guardarEn(DIR_FILES."productos/productos");
        
         $original = DIR_FILES."productos/productos/".$id.".".$upload->obtenerExtUpload();
         $mini     = DIR_FILES."productos/productos/".$id."_80x80.".$upload->obtenerExtUpload();
         $thumb    = new imagenMiniatura($original,$mini);
         $thumb->crear(ANCHO_THUMB_1,ALTO_THUMB_1);

          $sql = "UPDATE producto_cont SET tipo = '".$upload->obtenerExtUpload()."' WHERE(id = '{$id}')";
          $this->ejecutarConsulta($sql);
    }

    private function deleteImage($id){
        $resp = $this->selecionarPorId($id);
        
        @unlink(DIR_FILES."productos/productos/".$resp['id'].".".$resp['tipo']);
        @unlink(DIR_FILES."productos/productos/".$resp['id']."_80x80.".$resp['tipo']);

        $sql = "UPDATE producto_cont SET tipo = '' WHERE(id = '{$id}')";
        $this->ejecutarConsulta($sql);  
    }
	
    public function ejecutarConsulta($sql){
        $conector=new ConectorMySQL(MYSQL_BD,MYSQL_HOST,MYSQL_USER,MYSQL_PASSWORD);
        $resp=$conector->consultar($sql);
        //$conector->desconectar();
        return $resp;
    }
}
?>